
//references for bibLaTex entry and field types, usefull for tooltips and so on.
//mostly copied from: Lehman & Kime & Boruvka & Wright (2013): The biblatex Package: Programmable Bibliographies and Citations (V.: 2.8a).
//http://mirrors.ctan.org/macros/latex/contrib/biblatex/doc/biblatex.pdf

var biblatexFields = {
"entrysubtype":
	"This field, which is not used by the standard styles, may be used to specify a subtype of an entry type. This may be useful for bibliography styles which support a finer-grained set of entry types."
,
"author":
	"The author(s) of the title."
,
"shortauthor":
	"The author(s) of the work, given in an abbreviated form. This field is mainly intended for abbreviated forms of corporate authors."
,
"shorteditor":
	"The editor(s) of the work, given in an abbreviated form. This field is mainly intended for abbreviated forms of corporate editors."
,
"altauthor":
	"An alternate notation for the author(s)."
,
"nameaddon":
	"An addon to be printed immediately after the author name in the bibliography. This field may be useful to add an alias or pen name (or give the real name if the pseudonym is commonly used to refer to that author)."
,
"affiliation":
	"The authors affiliation."
,
"indextitle":
	"A title to use for indexing instead of the regular title field."
,
"title":
	"The title of the work."
,
"subtitle":
	"The subtitle of the work."
,
"titleaddon":
	"An annex to the title, to be printed in a different font."
,
"shorttitle":
	"The title in an abridged form. This field is usually not included in the bibliography. It is intended for citations in author-title format. If present, the author-title citation styles use this field instead of title."
,
"editor":
	"The editor(s) of the title, booktitle, or maintitle, depending on the entry type."
,
"alteditor":
	"An alternate notation for the editor(s)."
,
"editortype":
	"The type of editorial role performed by this editor. Roles supported by default are editor, compiler, founder, continuator, redactor, reviser, collaborator."
,
"editoratype":
	"The type of editorial role performed by this editor. Roles supported by default are editor, compiler, founder, continuator, redactor, reviser, collaborator."
,
"editorbtype":
	"The type of editorial role performed by this editor. Roles supported by default are editor, compiler, founder, continuator, redactor, reviser, collaborator."
,
"editorctype":
	"The type of editorial role performed by this editor. Roles supported by default are editor, compiler, founder, continuator, redactor, reviser, collaborator."
,
"editordtype":
	"The type of editorial role performed by this editor. Roles supported by default are editor, compiler, founder, continuator, redactor, reviser, collaborator."
,
"editora":
	"A secondary editor performing a different editorial role, such as compiling, redacting, etc."
,
"editorb":
	"Another secondary editor performing a different role."
,
"editorc":
	"Another secondary editor performing a different role."
,
"editord":
	"Another secondary editor performing a different role."
,
"foreword":
	"The author(s) of a foreword to the work."
,
"preface":
	"The author(s) of a preface to the work."
,
"introduction":
	"The author(s) of an introduction to the work."
,
"afterword":
	"The author(s) of an afterword to the work."
,
"addendum":
	"Miscellaneous bibliographic data to be printed at the end of the entry."
,
"commentator":
	"The author(s) of a commentary to the work. Note that this field is intended for commented editions which have a commentator in addition to the author, not for a stand-alone commentary"
,
"translator":
	"The translator(s) of the title or booktitle, depending on the entry type."
,
"annotator":
	"The author(s) of annotations to the work."
,
"bookauthor":
	"The author(s) of the booktitle."
,
"booktitle":
	"If the title field indicates the title of a work which is part of a larger publication, the title of the main work is given in this field."
,
"booksubtitle":
	"The subtitle related to the booktitle. If the subtitle field refers to a work which is part of a larger publication, a possible subtitle of the main work is given in this field."
,
"booktitleaddon" :
	"An annex to the booktitle, to be printed in a different font."
,
"shortbooktitle":
	"The booktitle in an abridged form."
,
"maintitle":
	"The main title of a multi-volume book, such as Collected Works. If the title or booktitle field indicates the title of a single volume which is part of multi-volume book, the title of the complete work is given in this field."
,
"mainsubtitle":
	"The subtitle related to the maintitle."
,
"maintitleaddon":
	"An annex to the maintitle, to be printed in a different font."
,
"shortmaintitle":
	"The maintitle in an abridged form."
,
"journal":
	"The name of a journal, a newspaper, or some other periodical."
,
"journaltitle":
	"The name of a journal, a newspaper, or some other periodical."
,
"journalsubtitle":
	"The subtitle of a journal, a newspaper, or some other periodical."
,
"journaltitleaddon":
	"An annex to the journal title, to be printed in a different font."
,
"shortjournal":
	"A short version or an acronym of the journal title."
,
"series":
	"In case of periodicals, the number or designation of a journal series, either as digit, literal string, or localization key. For stand-alone works, the name of a loosely related sequence of books by the same publisher which deal with the same general topic or belong to the same field of research, such as “Studies in ...”. Books in a publication series are usually numbered. The number or volume of a book in a series is given in the number field."
,
"seriessubtitle":
	"The subtitle of a publication series"
,
"seriestitleaddon":
	"An annex to the publication series title, to be printed in a different font."
,
"shortseries":
	"A short version or an acronym of the series field."
,
"volume":
	"The volume of a periodical or a multi-volume book (in which case it is referring to maintitle)"
,
"volumes":
	"The total number of volumes of a multi-volume work. Depending on the entry type, this field refers to title or maintitle."
,
"number":
	"The number of a journal, or the volume/number of a book (in which case this field refers to the publication series)."
,
"issue":
	"The issue of a journal. This field is intended for journals whose individual issues are identified by a designation such as ‘Spring’ or ‘Summer’ rather than the month or a number. Since the placement of issue is similar to month and number, this field may also be useful with double issues and other special cases."
,
"issuetitle":
	"The title of a specific issue of a journal or other periodical."
,
"issuesubtitle":
	"The subtitle of a specific issue of a journal or other periodical."
,
"issuetitleaddon":
	"An annex to a specific issue title."
,
"shortissuetitle":
	"A short version or an acronym of the journal title"
,
"part":
	"The number of a partial volume. This field applies to books only, not to journals. It may be used when a logical volume consists of two or more physical ones. In this case the number of the logical volume goes in the volume field and the number of the part of that volume in the part field."
,
"chapter":
	"A chapter or section or any other unit of a work."
,
"edition":
	"The edition of a printed publication. This must be an integer, not an ordinal. Don’t say edition={First} or edition={1st} but edition={1}. The bibliography style converts this to a language dependent ordinal. It is also possible to give the edition as a literal string, for example “Third, revised and expanded edition”."
,
"version":
	"The revision number of a piece of software, a manual, etc."
,
"pages":
	"One or more page numbers or page ranges. If the work is published as part of another one, such as an article in a journal or a collection, this field holds the relevant page range in that other work. It may also be used to limit the reference to a specific part of a work (a chapter in a book, for example)."
,
"pagetotal":
	"The total number of pages of the work."
,
"pagination":
	"The pagination of the work. The value of this field will affect the formatting the postnote argument to a citation command. The key should be given in the singular form. Possible keys are page, column, line, verse, section, and paragraph."
,
"location":
	"The place(s) of publication, i. e., the location of the publisher or institution, depending on the entry type."
,
"address":
	"An alias for location, provided for BibTeX compatibility. Traditional BibTeX uses the slightly misleading field name address for the place of publication, i. e., the location of the publisher, while Biblatex uses the generic field name location."
,
"publisher":
	"The name(s) of the publisher(s)."
,
"shortpublisher":
	"A short version or an acronym of the publisher(s)."
,
"school":
	"An alias for institution, provided for BibTeX compatibility. The institution field is used by traditional BibTeX for technical reports whereas the school field holds the institution associated with theses. The Biblatex package employs the generic field name institution in both cases."
,
"institution":
	"The name of a university or some other institution, depending on the entry type. Traditional BibTeX uses the field name school for theses, which is supported as an alias."
,
"howpublished":
	"A publication notice for unusual publications which do not fit into any of the common categories."
,
"pubstate":
	"The publication state of the work, e. g., ‘in press’. Known publication states: \n[inpreparation]  The expression ‘in preparation’ (the manuscript is being prepared for publication). \n[submitted] The expression ‘submitted’ (the manuscript has been submitted to a journal or conference). \n[forthcoming] The expression ‘forthcoming’ (the manuscript has been accepted by a press or journal). \n[inpress] The expression ‘in press’ (the manuscript is fully copyedited and out of the author’s hands; it is in the final stages of the production process). \n[prepublished] The expression ‘pre-published’ (the manuscript is published in a preliminary form or location, such as online version in advance of print publication)."
,
"type":
	"The type of a manual, patent, report, or thesis. This field may also be useful for custom types."
,
"year":
	"The year of publication."
,
"date":
	"The publication date. Require a date specification in yyyy-mm-dd format. Date ranges are given as yyyy-mm-dd/ yyyy-mm-dd. Partial dates are valid provided that date components are omitted at the end only. You may specify an open ended date range by giving the range separator and omitting the end date (e. g., yyyy/). The formatted date is language specific and will be adapted automatically. If there is no date field in an entry, Biblatex will also consider the fields year and month for backwards compatibility with traditional BibTeX."
,
"month":
	"The publication month. This is an integer field, not an ordinal or a string. For backwards compatibility, you may also use the following three-letter abbreviations in the month field: jan, feb, mar, apr, may, jun, jul, aug, sep, oct, nov, dec. Note that these abbreviations are BibTeX strings which must be given without any braces or quotes."
,
"doi":
	"The Digital Object Identifier of the work."
,
"url":
	"The url of an online publication."
,
"alturl":
	"A second url of an online publication."
,
"urldate":
	"The access date of the address specified in the url field."
,
"eprint":
	"The electronic identifier of an online publication. This is roughly comparable to a doi but specific to a certain archive, repository, service, or system."
,
"language":
	"The language(s) of the work. Languages may be specified literally or as localization keys."
,
"contents":
	"Provides information about the contents, ideally a a table of contents."
,
"abstract":
	"This field is intended for recording abstracts in a bib file, to be printed by a special bibliography style."
,
"keywords":
	"A separated list of keywords. These keywords are intended for the bibliography filters."
,
"review":
	"Provides review(s) of the selected work."
,
"reviewof":
	"For reviews, provides information about the hereby reviewed work(s)."
,
"crossref":
	"This field holds an entry key for the cross-referencing feature. Child entries with a crossref field inherit data from the parent entry specified in the crossref field. If the number of child entries referencing a specific parent entry hits a certain threshold, the parent entry is automatically added to the bibliography even if it has not been cited explicitly. The threshold is settable with the mincrossrefs package option from § 3.1.2.1. Style authors should note that whether or not the crossref fields of the child entries are defined on the Biblatex level depends on the availability of the parent entry. If the parent entry is available, the crossref fields of the child entries will be defined. If not, the child entries still inherit the data from the parent entry but their crossref fields will be undefined. Whether the parent entry is added to the bibliography implicitly because of the threshold or explicitly because it has been cited does not matter."
,
"xref":
	"This field is an alternative cross-referencing mechanism. It differs from crossref in that the child entry will not inherit any data from the parent entry specified in the xref field. If the number of child entries referencing a specific parent entry hits a certain threshold, the parent entry is automatically added to the bibliography even if it has not been cited explicitly. The threshold is settable with the mincrossrefs package option from § 3.1.2.1. Style authors should note that whether or not the xref fields of the child entries are defined on the Biblatex level depends on the availability of the parent entry. If the parent entry is available, the xref fields of the child entries will be defined. If not, their xref fields will be undefined. Whether the parent entry is added to the bibliography implicitly because of the threshold or explicitly because it has been cited does not matter."
,
"eventtitle":
	"The (plain) title of a conference, a symposium, or some other event in @proceedings and @inproceedings entries."
,
"shorteventtitle":
	"An abbreviated form of  the title of a conference, a symposium, or some other event."
,
"eventsubtitle":
	"Subtitle of the title of a conference, symposium, or some other event"
,
"eventtitleaddon":
	"An annex to the eventtitle field. Can be used for known event acronyms, for example."
,
"eventdate":
	"The date of a conference, a symposium, or some other event in @proceedings and @inproceedings entries."
,
"eventurl":
	"An URL for a conference, a symposium, or some other event."
,
"venue":
	"The location of a conference, a symposium, or some other event in @proceedings and @inproceedings entries. Note that the location list holds the place of publication. It therefore corresponds to the publisher and institution lists. The location of the event is given in the venue field."
,
"organization":
	"The organization(s) that published a @manual or an @online resource, or sponsored a conference."
,
"shortorganization":
	"An acronym for the organization(s) that published a @manual or an @online resource, or sponsored a conference."
,
"origauthor":
	"The original author of a piece of work"
,
"origbooktitle":
	"If the work is a translation, a reprint, or something similar, the booktitle of the original work."
,
"origdate":
	"If the work is a translation, a reprint, or something similar, the publication date of the original edition."
,
"origedition":
	"If the work is a translation, a reprint, or something similar, the edition of the original work."
,
"origjournal":
	"If the work is a translation, a reprint, or something similar, the journal title of the original work."
,
"origjournaltitle":
	"If the work is a translation, a reprint, or something similar, the journal title of the original work."
,
"origlanguage":
	"If the work is a translation or something similar, the language of the original work."
,
"origlocation":
	"If the work is a translation, a reprint, or something similar, the location of the original edition."
,
"origpages":
	"If the work is a translation, a reprint, or something similar, the pages of the original edition."
,
"origpublisher":
	"If the work is a translation, a reprint, or something similar, the publisher of the original edition."
,
"origseries":
	"If the work is a translation, a reprint, or something similar, the series of the original edition."
,
"origsubtitle":
	"If the work is a translation, a reprint, or something similar, the subtitle of the original edition."
,
"origtitle":
	"If the work is a translation, a reprint, or something similar, the title of the original edition."
,
"origvolume":
	"If the work is a translation, a reprint, or something similar, the volume of the original edition."
,
"reprintdate":
	"The date of a reprint of the work."
,
"reprintissn":
	"The journal ISSN of a reprint of the work."
,
"reprintlocation":
	"The location of a reprint of the work."
,
"reprintpublisher":
	"The publisher(s) of a reprint of the work."
,
"reprintseries":
	"The series of a reprint of the work."
,
"reprinttitle":
	"The title of a reprint of the work."
,
"reprinturl":
	"The URL of a reprint of the work."
,
"reprintyear":
	"The year of a reprint of the work."
,
"featured_book":
	""
,
"copyright":
	"A copyright notice for this work."
,
"timestamp":
	"Date of incorporation into BibMAS database."
,
"options":
	"A separated list of entry options in key = value notation. This field is used to set options on a per-entry basis."
,
"bibmas_file":
	"Originally, the FILE field provides the possibility to open file links e.g. in JabRef. Due to copyright issues, this is currently not supported by BibMAS and the field is disabled so it does not interfere with your own file link grabs."
,
"note":
	"Miscellaneous bibliographic data which does not fit into any other field. The note field may be used to record bibliographic data in a free format. Publication facts such as “Reprint of the edition London 1831” are typical candidates for the note field."
,
"comment":
	""
,
"bibmas_note":
	"An internal note in the BibMAS database."
,
"bibmas_src":
	"Reference to where BibMAS retrieved this entry from."
,
"walker_note":
	"A note by C.B.F. Walker."
,
"gent_note":
	"A note by Rob van Gent."
,
"thompson_note":
	"A note by Gary D. Thompson."
,
"annote":
	"An alias for annotation. This field may be useful when implementing a style for annotated bibliographies. Note that this field is completely unrelated to annotator. The annotator is the author of annotations which are part of the work cited."
,
"annotation":
	"This field may be useful when implementing a style for annotated bibliographies. Note that this field is completely unrelated to annotator. The annotator is the author of annotations which are part of the work cited."
,
"source":
	""
,
"library":
	"This field may be useful to record information such as a library name and a call number. This may be printed by a special bibliography style if desired."
,
"isbn":
	"The International Standard Book Number of a book."
,
"issn":
	"The International Standard Serial Number of a periodical."
,
"oclc":
	"Online Computer Library Center identification."
,
"lccn":
	"Library of Congress Control Number."
,
"ean":
	"European Article Number."
,
"asin":
	"Amazon Standard Identification Number"
,
"keibi":
	"Keilschrift-Bibliographie Tübingen identifier."
,
"ebscourl":
	"EBSCO URL."
,
"masid":
	""
,
"mrclass":
	"Mathematical Review Class."
,
"mrnumber":
	"Mathematical Review Number."
,
"price":
    "The price of the document."
,
"size":
    "The physical dimensions of a work."
,
"mrreviewer":
	"The reviewer in Mathematical Review."
,
"identifier":
	""
,
"interhash":
	""
,
"intrahash":
	""
,
"added-at":
	""
,
"adsnote":
	"SAO/NASA ADS note."
,
"adsurl":
	"SAO/NASA ADS url."
,
"biburl":
	""
,
"catalogue-url":
	""
,
"jstor_articletype":
	"JSTOR internal article type designation."
,
"jstor_formatteddate":
	"JSTOR internal date formatting."
,
"jstor_issuetitle":
	"JSTOR internal formatting for periodical issue title."
,
"ppn":
	""
,
"subjects":
	""
,
"related":
	"Citation keys of other entries which have a relationship to this entry. The relationship is specified by the relatedtype field."
,
"relatedoptions":
	"Per-type options to set for a related entry. Note that this does not set the options on the related entry itself, only the dataonly clone which is used as a datasource for the parent entry."
,
"relatedtype":
	"An identifier which specified the type of relationship for the keys listed in the related field. The identifier is a localized bibliography string printed before the data from the related entry list. It is also used to identify type-specific formatting directives and bibliography macros for the related entries."
,
"relatedstring":
	"A field used to override the bibliography string specified by relatedtype."
,
"sortkey":
	"A field used to modify the sorting order of the bibliography. Think of this field as the master sort key. If present, Biblatex uses this field during sorting and ignores everything else, except for the presort field."
,
"sortname":
	"A name or a list of names used to modify the sorting order of the bibliography. If present, this list is used instead of author or editor when sorting the bibliography."
,
"gender":
	"The gender of the author or the gender of the editor, if there is no author. The following identifiers are supported: sf (feminine singular, a single female name), sm (masculine singular, a single male name), sn (neuter singular, a single neuter name), pf (feminine plural, a list of female names), pm (masculine plural, a list of male names), pn (neuter plural, a list of neuter names), pp (plural, a mixed gender list of names). This information is only required by special bibliography and citation styles and only in certain languages. For example, a citation style may replace recurrent author names with a term such as ‘idem’. If the Latin word is used, as is custom in English and French, there is no need to specify the gender. In German publications, however, such key terms are usually given in German and in this case they are gender-sensitive."
,
"key":
    "Used for alphabetizing, cross referencing, and creating a label when the ``author'' information is missing. This field should not be confused with the key that appears in the cite command and at the beginning of the database entry."
,
"sorttitle":
	"A field used to modify the sorting order of the bibliography. If present, this field is used instead of the title field when sorting the bibliography. The sorttitle field may come in handy if you have an entry with a title like “An Introduction to...” and want that alphabetized under ‘I’ rather than ‘A’. In this case, you could put “Introduction to...” in the sorttitle field."
};

var biblatexTypes = {
"article":
	"An article in a journal, magazine, newspaper, or other periodical which forms a self-contained unit with its own title. The title of the periodical is given in the journaltitle field. If the issue has its own title in addition to the main title of the periodical, it goes in the issuetitle field. Note that editor and related fields refer to the journal while translator and related fields refer to the article."
,
"mvbook":
	"A multi-volume @book. For backwards compatibility, multi-volume books are also supported by the entry type @book. However, it is advisable to make use of the dedicated entry type @mvbook."
,
"inbook":
	"A part of a book which forms a self-contained unit with its own title. Note that the profile of this entry type is different from standard BibTeX. Use the @inbook entry type for a self-contained part of a book with its own title only. It relates to @book just like @incollection relates to @collection. If you want to refer to a chapter or section of a book, simply use the book type and add a chapter and/or pages field. Whether a bibliography should at all include references to chapters or sections is controversial because a chapter is not a bibliographic entity."
,
"book":
	"A single-volume book with one or more authors where the authors share credit for the work as a whole. This entry type also covers the function of the @inbook type of traditional BibTeX: Use the @inbook entry type for a self-contained part of a book with its own title only. It relates to @book just like @incollection relates to @collection. If you want to refer to a chapter or section of a book, simply use the book type and add a chapter and/or pages field. Whether a bibliography should at all include references to chapters or sections is controversial because a chapter is not a bibliographic entity."
,
"bookinbook":
	"This type is similar to @inbook but intended for works originally published as a stand-alone book. A typical example are books reprinted in the collected works of an author."
,
"suppbook":
	"Supplemental material in a @book. This type is closely related to the @inbook entry type. While @inbook is primarily intended for a part of a book with its own title (e. g., a single essay in a collection of essays by the same author), this type is provided for elements such as prefaces, introductions, forewords, afterwords, etc. which often have a generic title only. Style guides may require such items to be formatted differently from other @inbook items. The standard styles will treat this entry type as an alias for @inbook."
,
"booklet":
	"A book-like work without a formal publisher or sponsoring institution. Use the field howpublished to supply publishing information in free format, if applicable. The field type may be useful as well."
,
"collection":
	"A single-volume collection with multiple, self-contained contributions by distinct authors which have their own title. The work as a whole has no overall author but it will usually have an editor."
,
"mvcollection":
	"A multi-volume @collection. For backwards compatibility, multi-volume collections are also supported by the entry type @collection. However, it is advisable to make use of the dedicated entry type @mvcollection."
,
"incollection":
	"A contribution to a collection which forms a self-contained unit with a distinct author and title. The author refers to the title, the editor to the booktitle, i. e., the title of the collection."
,
"suppcollection":
	"Supplemental material in a @collection. This type is similar to @suppbook but related to the @collection entry type. The standard styles will treat this entry type as an alias for @incollection."
,
"manual":
	"Technical or other documentation, not necessarily in printed form. The author or editor is omissible."
,
"misc":
	"A fallback type for entries which do not fit into any other category. Use the field howpublished to supply publishing information in free format, if applicable. The field type may be useful as well. author, editor, and year are omissible."
,
"online":
	"An online resource. author, editor, and year are omissible. This entry type is intended for sources such as web sites which are intrinsically online resources. Note that all entry types support the url field. For example, when adding an article from an online journal, it may be preferable to use the @article type and its url field."
,
"patent":
	"A patent or patent request. The number or record token is given in the number field. Use the type field to specify the type and the location field to indicate the scope of the patent, if different from the scope implied by the type."
,
"periodical":
	"An complete issue of a periodical, such as a special issue of a journal. The title of the periodical is given in the title field. If the issue has its own title in addition to the main title of the periodical, it goes in the issuetitle field."
,
"suppperiodical":
	"Supplemental material in a @periodical. This type is similar to @suppbook but related to the @periodical entry type. The role of this entry type may be more obvious if you bear in mind that the @article type could also be called @inperiodical. This type may be useful when referring to items such as regular columns, obituaries, letters to the editor, etc. which only have a generic title. Style guides may require such items to be formatted differently from articles in the strict sense of the word. The standard styles will treat this entry type as an alias for @article."
,
"proceedings":
	"A single-volume conference proceedings. This type is very similar to @collection. It supports an optional organization field which holds the sponsoring institution."
,
"mvproceedings":
	"A multi-volume @proceedings entry. For backwards compatibility, multi-volume proceedings are also supported by the entry type @proceedings. However, it is advisable to make use of the dedicated entry type @mvproceedings."
,
"inproceedings":
	"An article in a conference proceedings. This type is similar to @incollection. It supports an optional organization field."
,
"reference":
	"A single-volume work of reference such as an encyclopedia or a dictionary. This is a more specific variant of the generic @collection entry type. The standard styles will treat this entry type as an alias for @collection."
,
"mvreference":
	"A multi-volume @reference entry. The standard styles will treat this entry type as an alias for @mvcollection. For backwards compatibility, multi-volume references are also supported by the entry type @reference. However, it is advisable to make use of the dedicated entry type @mvreference."
,
"inreference":
	"An article in a work of reference. This is a more specific variant of the generic @incollection entry type. The standard styles will treat this entry type as an alias for @incollection."
,
"report":
	"A technical report, research report, or white paper published by a university or some other institution. Use the type field to specify the type of report. The sponsoring institution goes in the institution field."
,
"thesis":
	"A thesis written for an educational institution to satisfy the requirements for a degree. Use the type field to specify the type of thesis."
,
"unpublished":
	"A work with an author and a title which has not been formally published, such as a manuscript or the script of a talk. Use the fields howpublished and note to supply additional information in free format, if applicable."
,
"conference":
	"A BibTeX legacy alias for @inproceedings."
,
"electronic":
	"An alias for @online."
,
"mastersthesis":
	"Similar to @thesis except that the type field is optional and defaults to the localized term ‘Master’s thesis’. You may still use the type field to override that."
,
"phdthesis":
	"Similar to @thesis except that the type field is optional and defaults to the localized term ‘PhD thesis’. You may still use the type field to override that."
,
"techreport":
	"Similar to @report except that the type field is optional and defaults to the localized term ‘technical report’. You may still use the type field to override that."
,
"www":
	"An alias for @online, provided for jurabib compatibility."
,
"audio"
:  "Audio recordings, typically on audio cd, dvd, audio cassette, or similar media. See also @music."
,
"letter":
	"Personal correspondence such as letters, emails, memoranda, etc. movie Motion pictures. See also @video."
,
"music":
	"Musical recordings. This is a more specific variant of @audio."
,
"performance":
	"Musical and theatrical performances as well as other works of the performing arts. This type refers to the event as opposed to a recording, a score, or a printed play."
,
"review":
	"Reviews of some other work. This is a more specific variant of the @article type. The standard styles will treat this entry type as an alias for @article."
,
"software":
	"Computer software."
};

var biblatexLocalizationkeys = {
"editor":
	"The main editor. This is the most generic editorial role and the default value."
,
"compiler": 
	"Similar to editor but used if the task of the editor is mainly compiling."
,
"founder":
	"The founding editor of a periodical or a comprehensive publication project such as a ‘Collected Works’ edition or a long-running legal commentary."
,
"continuator":
	"An editor who continued the work of the founding editor (founder) but was subsequently replaced by the current editor (editor)."
,
"redactor": 
	"A secondary editor whose task is redacting the work."
,
"reviser":
	"A secondary editor whose task is revising the work."
,
"collaborator":
	"A secondary editor or a consultant to the editor."
,
"editortr":
	"Used if editor/translator are identical."
,
"editorstr":
	 "The plural form of editortr."
,
"editorco":
	"Used if editor/commentator are identical."
,
"editorsco":
	"The plural form of editorco."
,
"editoran":
	 "Used if editor/annotator are identical."
,
"editorsan":
	 "The plural form of editoran."
,
"editorin":
	 "Used if editor/introduction are identical."
,
"editorsin":
	"The plural form of editorin."
,
"editorfo":
	"Used if editor/foreword are identical."
,
"editorsfo":
	 "The plural form of editorfo."
,
"editoraf":
	"Used if editor/aftword are identical."
,
"editorsaf":
	"The plural form of editoraf."
,
"editortrco":
	 "Used if editor/translator/commentator are identical."
,
"editorstrco":
	 "The plural form of editortrco."
,
"editortran":
	 "Used if editor/translator/annotator are identical."
,
"editorstran":
	 "The plural form of editortran."
,
"editortrin":
	"Used if editor/translator/introduction are identical."
,
"editorstrin":
	"The plural form of editortrin."
,
"editortrfo":
	"Used if editor/translator/foreword are identical."
,
"editorstrfo":
	 "The plural form of editortrfo."
,
"editortraf":
	 "Used if editor/translator/aftword are identical."
,
"editorstraf":
	"The plural form of editortraf."
,
"editorcoin":
	 "Used if editor/commentator/introduction are identical."
,
"editorscoin":
	"The plural form of editorcoin."
,
"editorcofo":
	"Used if editor/commentator/foreword are identical."
,
"editorscofo":
	 "The plural form of editorcofo."
,
"editorcoaf":
	 "Used if editor/commentator/aftword are identical."
,
"editorscoaf":
	 "The plural form of editorcoaf."
,
"editoranin":
	 "Used if editor/annotator/introduction are identical."
,
"editorsanin":
	"The plural form of editoranin."
,
"editoranfo":
	"Used if editor/annotator/foreword are identical.",
"editorsanfo":
	"The plural form of editoranfo.",
"editoranaf":
	"Used if editor/annotator/aftword are identical.",
"editorsanaf":
	"The plural form of editoranaf."
,
"editortrcoin":
	 "Used if editor/translator/commentator/introduction are identical."
,
"editorstrcoin":
	 "The plural form of editortrcoin."
,
"editortrcofo":
	"Used if editor/translator/commentator/foreword are identical.",
"editorstrcofo":
	"The plural form of editortrcofo."
,
"editortrcoaf":
	 "Used if editor/translator/commentator/aftword are identical."
,
"editorstrcoaf":
	 "The plural form of editortrcoaf."
,
"editortranin":
	 "Used if editor/annotator/commentator/introduction are identical."
,
"editorstranin":
	"The plural form of editortranin."
,
"editortranfo":
	"Used if editor/annotator/commentator/foreword are identical."
,
"editorstranfo":
	 "The plural form of editortranfo."
,
"editortranaf":
	"Used if editor/annotator/commentator/aftword are identical."
,
"editorstranaf":
	"The plural form of editortranaf."
,
"volume":
	 "The term ‘volume’, referring to a book."
,
"volumes":
	"The plural form of volume."
,
"involumes":
	"The term ‘in’, as used in expressions like ‘in number of volumes volumes’."
,
"jourvol":
	 "The term ‘volume’, referring to a journal."
,
"jourser":
	 "The term ‘series’, referring to a journal."
,
"book":
	 "The term ‘book’, referring to a document division."
,
"part" :"The term ‘part’, referring to a part of a book or a periodical."
,
"issue":
	 "The term ‘issue’, referring to a periodical."
,
"newseries":
	"The expression ‘new series’, referring to a journal."
,
"oldseries":
	 "The expression ‘old series’, referring to a journal."
,
"edition":
	"The term ‘edition’."
,
"in":
	 "The term ‘in’, referring to the title of a work published as part of another one, e. g.,‘ title of article in title of journal ’."
,
"inseries" :"The term ‘in’, as used in expressions like ‘volume number in name of series ’."
,
"ofseries":
	"The term ‘of’, as used in expressions like ‘volume number of name of series ’."
,
"number":
	 "The term ‘number’, referring to an issue of a journal."
,
"chapter":
	 "The term ‘chapter’, referring to a chapter in a book."
,
"version":
	 "The term ‘version’, referring to a revision number."
,
"reprint" :"The term ‘reprint’."
,
"reprintof":
	"The expression ‘reprint of title ’."
,
"reprintas":
	"The expression ‘reprinted as title ’."
,
"reprintfrom":
	"The expression ‘reprinted from title ’."
,
"translationof":
	"The expression ‘translation of title ’."
,
"translationas":
	"The expression ‘translated as title ’."
,
"translationfrom":
	 "The expression ‘translated from [the] language ’."
,
"reviewof":
	"The expression ‘review of title ’."
,
"origpubas":
	"The expression ‘originally published as title ’."
,
"origpubin":
	"The expression ‘originally published in year ’."
,
"astitle":
	"The term ‘as’, as used in expressions like ‘published by publisher as title ’."
,
"bypublisher":
	"The term ‘by’, as used in expressions like ‘published by publisher ’."
,
"inpreparation":
	"The expression ‘in preparation’ (the manuscript is being prepared for publication)."
,
"submitted":
	 "The expression ‘submitted’ (the manuscript has been submitted to a journal or conference)."
,
"forthcoming":
	"The expression ‘forthcoming’ (the manuscript has been accepted by a press or journal)."
,
"inpress":
	 "The expression ‘in press’ (the manuscript is fully copyedited and out of the author’s hands; it is in the final stages of the production process)."
,
"prepublished":
	 "The expression ‘pre-published’ (the manuscript is published in a preliminary form or location, such as online version in advance of print publication)."
,
"page":
	 "The term ‘page’."
,
"pages":
	 "The plural form of page."
,
"column":
	"The term ‘column’, referring to a column on a page."
,
"columns":
	"The plural form of column."
,
"section":
	"The term ‘section’, referring to a document division (usually abbreviated as §)."
,
"sections":
	"The plural form of section (usually abbreviated as §§)."
,
"paragraph":
	 "The term ‘paragraph’ (i. e., a block of text, not to be confused with section)."
,
"paragraphs":
	"The plural form of paragraph."
,
"verse":
	"The term ‘verse’ as used when referring to a work which is cited by verse numbers."
,
"verses":
	"The plural form of verse."
,
"line":
	"The term ‘line’ as used when referring to a work which is cited by line numbers."
,
"lines":
	"The plural form of line."
,
"mathesis":
	"An expression equivalent to the term ‘Master’s thesis’."
,
"phdthesis":
	"The term ‘PhD thesis’, ‘PhD dissertation’, ‘doctoral thesis’, etc."
,
"candthesis":
	"An expression equivalent to the term ‘Candidate thesis’. Used for ‘Candidate’ degrees that have no clear equivalent to the Master’s or doctoral level."
,
"techreport":
	"The term ‘technical report’."
,
"resreport":
	"The term ‘research report’."
,
"software":
	"The term ‘computer software’."
,
"datacd":
	"The term ‘data cd’ or ‘cd-rom’."
,
"audiocd":
	"The term ‘audio cd’."
};
