///bibmas using datatables extension/plugin 

///*! Scroller 1.2.2
 //* Â©2011-2014 SpryMedia Ltd - datatables.net/license
 //*/

///**
 //* @summary     Scroller
 //* @description Virtual rendering for DataTables
 //* @version     1.2.2
 //* @file        dataTables.scroller.js
 //* @author      SpryMedia Ltd (www.sprymedia.co.uk)
 //* @contact     www.sprymedia.co.uk/contact
 //* @copyright   Copyright 2011-2014 SpryMedia Ltd.
 //*
 //* This source file is free software, available under the following license:
 //*   MIT license - http://datatables.net/license/mit
 //*
 //* This source file is distributed in the hope that it will be useful, but
 //* WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 //* or FITNESS FOR A PARTICULAR PURPOSE. See the license files for details.
 //*
 //* For details please refer to: http://www.datatables.net
 //*/

//(function(window, document, undefined){


//var factory = function( $, DataTable ) {
//"use strict";

///**
 //* Scroller is a virtual rendering plug-in for DataTables which allows large
 //* datasets to be drawn on screen every quickly. What the virtual rendering means
 //* is that only the visible portion of the table (and a bit to either side to make
 //* the scrolling smooth) is drawn, while the scrolling container gives the
 //* visual impression that the whole table is visible. This is done by making use
 //* of the pagination abilities of DataTables and moving the table around in the
 //* scrolling container DataTables adds to the page. The scrolling container is
 //* forced to the height it would be for the full table display using an extra
 //* element.
 //*
 //* Note that rows in the table MUST all be the same height. Information in a cell
 //* which expands on to multiple lines will cause some odd behaviour in the scrolling.
 //*
 //* Scroller is initialised by simply including the letter 'S' in the sDom for the
 //* table you want to have this feature enabled on. Note that the 'S' must come
 //* AFTER the 't' parameter in `dom`.
 //*
 //* Key features include:
 //*   <ul class="limit_length">
 //*     <li>Speed! The aim of Scroller for DataTables is to make rendering large data sets fast</li>
 //*     <li>Full compatibility with deferred rendering in DataTables 1.9 for maximum speed</li>
 //*     <li>Display millions of rows</li>
 //*     <li>Integration with state saving in DataTables (scrolling position is saved)</li>
 //*     <li>Easy to use</li>
 //*   </ul>
 //*
 //*  @class
 //*  @constructor
 //*  @global
 //*  @param {object} oDT DataTables settings object
 //*  @param {object} [oOpts={}] Configuration object for FixedColumns. Options 
 //*    are defined by {@link Scroller.defaults}
 //*
 //*  @requires jQuery 1.7+
 //*  @requires DataTables 1.9.0+
 //*
 //*  @example
 //*    $(document).ready(function() {
 //*        $('#example').dataTable( {
 //*            "sScrollY": "200px",
 //*            "sAjaxSource": "media/dataset/large.txt",
 //*            "sDom": "frtiS",
 //*            "bDeferRender": true
 //*        } );
 //*    } );
 //*/
//var Scroller = function ( oDTSettings, oOpts ) {
	///* Sanity check - you just know it will happen */
	//if ( ! this instanceof Scroller )
	//{
		//alert( "Scroller warning: Scroller must be initialised with the 'new' keyword." );
		//return;
	//}

	//if ( typeof oOpts == 'undefined' )
	//{
		//oOpts = {};
	//}

	///**
	 //* Settings object which contains customisable information for the Scroller instance
	 //* @namespace
	 //* @private
	 //* @extends Scroller.defaults
	 //*/
	//this.s = {
		///**
		 //* DataTables settings object
		 //*  @type     object
		 //*  @default  Passed in as first parameter to constructor
		 //*/
		//"dt": oDTSettings,

		///**
		 //* Pixel location of the top of the drawn table in the viewport
		 //*  @type     int
		 //*  @default  0
		 //*/
		//"tableTop": 0,

		///**
		 //* Pixel location of the bottom of the drawn table in the viewport
		 //*  @type     int
		 //*  @default  0
		 //*/
		//"tableBottom": 0,

		///**
		 //* Pixel location of the boundary for when the next data set should be loaded and drawn
		 //* when scrolling up the way.
		 //*  @type     int
		 //*  @default  0
		 //*  @private
		 //*/
		//"redrawTop": 0,

		///**
		 //* Pixel location of the boundary for when the next data set should be loaded and drawn
		 //* when scrolling down the way. Note that this is actually calculated as the offset from
		 //* the top.
		 //*  @type     int
		 //*  @default  0
		 //*  @private
		 //*/
		//"redrawBottom": 0,

		///**
		 //* Auto row height or not indicator
		 //*  @type     bool
		 //*  @default  0
		 //*/
		//"autoHeight": true,

		///**
		 //* Number of rows calculated as visible in the visible viewport
		 //*  @type     int
		 //*  @default  0
		 //*/
		//"viewportRows": 0,

		///**
		 //* setTimeout reference for state saving, used when state saving is enabled in the DataTable
		 //* and when the user scrolls the viewport in order to stop the cookie set taking too much
		 //* CPU!
		 //*  @type     int
		 //*  @default  0
		 //*/
		//"stateTO": null,

		///**
		 //* setTimeout reference for the redraw, used when server-side processing is enabled in the
		 //* DataTables in order to prevent DoSing the server
		 //*  @type     int
		 //*  @default  null
		 //*/
		//"drawTO": null,

		//heights: {
			//jump: null,
			//page: null,
			//virtual: null,
			//scroll: null,

			///**
			 //* Height of rows in the table
			 //*  @type     int
			 //*  @default  0
			 //*/
			//row: null,

			///**
			 //* Pixel height of the viewport
			 //*  @type     int
			 //*  @default  0
			 //*/
			//viewport: null
		//},

		//topRowFloat: 0,
		//scrollDrawDiff: null,
		//loaderVisible: false
	//};

	//// @todo The defaults should extend a `c` property and the internal settings
	//// only held in the `s` property. At the moment they are mixed
	//this.s = $.extend( this.s, Scroller.oDefaults, oOpts );

	//// Workaround for row height being read from height object (see above comment)
	//this.s.heights.row = this.s.rowHeight;

	///**
	 //* DOM elements used by the class instance
	 //* @private
	 //* @namespace
	 //*
	 //*/
	//this.dom = {
		//"force":    document.createElement('div'),
		//"scroller": null,
		//"table":    null,
		//"loader":   null
	//};

	///* Attach the instance to the DataTables instance so it can be accessed */
	//this.s.dt.oScroller = this;

	///* Let's do it */
	//this._fnConstruct();
//};



//Scroller.prototype = /** @lends Scroller.prototype */{
	///* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 //* Public methods
	 //* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

	///**
	 //* Calculate the pixel position from the top of the scrolling container for
	 //* a given row
	 //*  @param {int} iRow Row number to calculate the position of
	 //*  @returns {int} Pixels
	 //*  @example
	 //*    $(document).ready(function() {
	 //*      $('#example').dataTable( {
	 //*        "sScrollY": "200px",
	 //*        "sAjaxSource": "media/dataset/large.txt",
	 //*        "sDom": "frtiS",
	 //*        "bDeferRender": true,
	 //*        "fnInitComplete": function (o) {
	 //*          // Find where row 25 is
	 //*          alert( o.oScroller.fnRowToPixels( 25 ) );
	 //*        }
	 //*      } );
	 //*    } );
	 //*/
	//"fnRowToPixels": function ( rowIdx, intParse, virtual )
	//{
		//var pixels;

		//if ( virtual ) {
			//pixels = this._domain( 'virtualToPhysical', rowIdx * this.s.heights.row );
		//}
		//else {
			//var diff = rowIdx - this.s.baseRowTop;
			//pixels = this.s.baseScrollTop + (diff * this.s.heights.row);
		//}

		//return intParse || intParse === undefined ?
			//parseInt( pixels, 10 ) :
			//pixels;
	//},


	///**
	 //* Calculate the row number that will be found at the given pixel position
	 //* (y-scroll).
	 //*
	 //* Please note that when the height of the full table exceeds 1 million
	 //* pixels, Scroller switches into a non-linear mode for the scrollbar to fit
	 //* all of the records into a finite area, but this function returns a linear
	 //* value (relative to the last non-linear positioning).
	 //*  @param {int} iPixels Offset from top to calculate the row number of
	 //*  @param {int} [intParse=true] If an integer value should be returned
	 //*  @param {int} [virtual=false] Perform the calculations in the virtual domain
	 //*  @returns {int} Row index
	 //*  @example
	 //*    $(document).ready(function() {
	 //*      $('#example').dataTable( {
	 //*        "sScrollY": "200px",
	 //*        "sAjaxSource": "media/dataset/large.txt",
	 //*        "sDom": "frtiS",
	 //*        "bDeferRender": true,
	 //*        "fnInitComplete": function (o) {
	 //*          // Find what row number is at 500px
	 //*          alert( o.oScroller.fnPixelsToRow( 500 ) );
	 //*        }
	 //*      } );
	 //*    } );
	 //*/
	//"fnPixelsToRow": function ( pixels, intParse, virtual )
	//{
		//var diff = pixels - this.s.baseScrollTop;
		//var row = virtual ?
			//this._domain( 'physicalToVirtual', pixels ) / this.s.heights.row :
			//( diff / this.s.heights.row ) + this.s.baseRowTop;

		//return intParse || intParse === undefined ?
			//parseInt( row, 10 ) :
			//row;
	//},


	///**
	 //* Calculate the row number that will be found at the given pixel position (y-scroll)
	 //*  @param {int} iRow Row index to scroll to
	 //*  @param {bool} [bAnimate=true] Animate the transition or not
	 //*  @returns {void}
	 //*  @example
	 //*    $(document).ready(function() {
	 //*      $('#example').dataTable( {
	 //*        "sScrollY": "200px",
	 //*        "sAjaxSource": "media/dataset/large.txt",
	 //*        "sDom": "frtiS",
	 //*        "bDeferRender": true,
	 //*        "fnInitComplete": function (o) {
	 //*          // Immediately scroll to row 1000
	 //*          o.oScroller.fnScrollToRow( 1000 );
	 //*        }
	 //*      } );
	 //*     
	 //*      // Sometime later on use the following to scroll to row 500...
	 //*          var oSettings = $('#example').dataTable().fnSettings();
	 //*      oSettings.oScroller.fnScrollToRow( 500 );
	 //*    } );
	 //*/
	//"fnScrollToRow": function ( iRow, bAnimate )
	//{
		//var that = this;
		//var ani = false;
		//var px = this.fnRowToPixels( iRow );

		//// We need to know if the table will redraw or not before doing the
		//// scroll. If it will not redraw, then we need to use the currently
		//// displayed table, and scroll with the physical pixels. Otherwise, we
		//// need to calculate the table's new position from the virtual
		//// transform.
		//var preRows = ((this.s.displayBuffer-1)/2) * this.s.viewportRows;
		//var drawRow = iRow - preRows;
		//if ( drawRow < 0 ) {
			//drawRow = 0;
		//}

		//if ( (px > this.s.redrawBottom || px < this.s.redrawTop) && this.s.dt._iDisplayStart !== drawRow ) {
			//ani = true;
			//px = this.fnRowToPixels( iRow, false, true );
		//}

		//if ( typeof bAnimate == 'undefined' || bAnimate )
		//{
			//this.s.ani = ani;
			//$(this.dom.scroller).animate( {
				//"scrollTop": px
			//}, function () {
				//// This needs to happen after the animation has completed and
				//// the final scroll event fired
				//setTimeout( function () {
					//that.s.ani = false;
				//}, 25 );
			//} );
		//}
		//else
		//{
			//$(this.dom.scroller).scrollTop( px );
		//}
	//},


	///**
	 //* Calculate and store information about how many rows are to be displayed
	 //* in the scrolling viewport, based on current dimensions in the browser's
	 //* rendering. This can be particularly useful if the table is initially
	 //* drawn in a hidden element - for example in a tab.
	 //*  @param {bool} [bRedraw=true] Redraw the table automatically after the recalculation, with
	 //*    the new dimensions forming the basis for the draw.
	 //*  @returns {void}
	 //*  @example
	 //*    $(document).ready(function() {
	 //*      // Make the example container hidden to throw off the browser's sizing
	 //*      document.getElementById('container').style.display = "none";
	 //*      var oTable = $('#example').dataTable( {
	 //*        "sScrollY": "200px",
	 //*        "sAjaxSource": "media/dataset/large.txt",
	 //*        "sDom": "frtiS",
	 //*        "bDeferRender": true,
	 //*        "fnInitComplete": function (o) {
	 //*          // Immediately scroll to row 1000
	 //*          o.oScroller.fnScrollToRow( 1000 );
	 //*        }
	 //*      } );
	 //*     
	 //*      setTimeout( function () {
	 //*        // Make the example container visible and recalculate the scroller sizes
	 //*        document.getElementById('container').style.display = "block";
	 //*        oTable.fnSettings().oScroller.fnMeasure();
	 //*      }, 3000 );
	 //*/
	//"fnMeasure": function ( bRedraw )
	//{
		//if ( this.s.autoHeight )
		//{
			//this._fnCalcRowHeight();
		//}

		//var heights = this.s.heights;

		//heights.viewport = $(this.dom.scroller).height();
		//this.s.viewportRows = parseInt( heights.viewport / heights.row, 10 )+1;
		//this.s.dt._iDisplayLength = this.s.viewportRows * this.s.displayBuffer;

		//if ( bRedraw === undefined || bRedraw )
		//{
			//this.s.dt.oInstance.fnDraw();
		//}
	//},



	///* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 //* Private methods (they are of course public in JS, but recommended as private)
	 //* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

	///**
	 //* Initialisation for Scroller
	 //*  @returns {void}
	 //*  @private
	 //*/
	//"_fnConstruct": function ()
	//{
		//var that = this;

		///* Sanity check */
		//if ( !this.s.dt.oFeatures.bPaginate ) {
			//this.s.dt.oApi._fnLog( this.s.dt, 0, 'Pagination must be enabled for Scroller' );
			//return;
		//}

		///* Insert a div element that we can use to force the DT scrolling container to
		 //* the height that would be required if the whole table was being displayed
		 //*/
		//this.dom.force.style.position = "absolute";
		//this.dom.force.style.top = "0px";
		//this.dom.force.style.left = "0px";
		//this.dom.force.style.width = "1px";

		//this.dom.scroller = $('div.'+this.s.dt.oClasses.sScrollBody, this.s.dt.nTableWrapper)[0];
		//this.dom.scroller.appendChild( this.dom.force );
		//this.dom.scroller.style.position = "relative";

		//this.dom.table = $('>table', this.dom.scroller)[0];
		//this.dom.table.style.position = "absolute";
		//this.dom.table.style.top = "0px";
		//this.dom.table.style.left = "0px";

		//// Add class to 'announce' that we are a Scroller table
		//$(this.s.dt.nTableWrapper).addClass('DTS');

		//// Add a 'loading' indicator
		//if ( this.s.loadingIndicator )
		//{
			//this.dom.loader = $('<div class="DTS_Loading">'+this.s.dt.oLanguage.sLoadingRecords+'</div>')
				//.css('display', 'none');

			//$(this.dom.scroller.parentNode)
				//.css('position', 'relative')
				//.append( this.dom.loader );
		//}

		///* Initial size calculations */
		//if ( this.s.heights.row && this.s.heights.row != 'auto' )
		//{
			//this.s.autoHeight = false;
		//}
		//this.fnMeasure( false );

		///* Scrolling callback to see if a page change is needed - use a throttled
		 //* function for the save save callback so we aren't hitting it on every
		 //* scroll
		 //*/
		//this.s.ingnoreScroll = true;
		//this.s.stateSaveThrottle = this.s.dt.oApi._fnThrottle( function () {
			//that.s.dt.oApi._fnSaveState( that.s.dt );
		//}, 500 );
		//$(this.dom.scroller).on( 'scroll.DTS', function (e) {
			//that._fnScroll.call( that );
		//} );

		///* In iOS we catch the touchstart event in case the user tries to scroll
		 //* while the display is already scrolling
		 //*/
		//$(this.dom.scroller).on('touchstart.DTS', function () {
			//that._fnScroll.call( that );
		//} );

		///* Update the scroller when the DataTable is redrawn */
		//this.s.dt.aoDrawCallback.push( {
			//"fn": function () {
				//if ( that.s.dt.bInitialised ) {
					//that._fnDrawCallback.call( that );
				//}
			//},
			//"sName": "Scroller"
		//} );

		///* On resize, update the information element, since the number of rows shown might change */
		//$(window).on( 'resize.DTS', function () {
			//that.fnMeasure( false );
			//that._fnInfo();
		//} );

		///* Add a state saving parameter to the DT state saving so we can restore the exact
		 //* position of the scrolling
		 //*/
		//var initialStateSave = true;
		//this.s.dt.oApi._fnCallbackReg( this.s.dt, 'aoStateSaveParams', function (oS, oData) {
			///* Set iScroller to saved scroll position on initialization.
			 //*/
			//if(initialStateSave && that.s.dt.oLoadedState){
				//oData.iScroller = that.s.dt.oLoadedState.iScroller;
				//oData.iScrollerTopRow = that.s.dt.oLoadedState.iScrollerTopRow;
				//initialStateSave = false;
			//} else {
				//oData.iScroller = that.dom.scroller.scrollTop;
				//oData.iScrollerTopRow = that.s.topRowFloat;
			//}
		//}, "Scroller_State" );

		//if ( this.s.dt.oLoadedState ) {
			//this.s.topRowFloat = this.s.dt.oLoadedState.iScrollerTopRow || 0;
		//}

		///* Destructor */
		//this.s.dt.aoDestroyCallback.push( {
			//"sName": "Scroller",
			//"fn": function () {
				//$(window).off( 'resize.DTS' );
				//$(that.dom.scroller).off('touchstart.DTS scroll.DTS');
				//$(that.s.dt.nTableWrapper).removeClass('DTS');
				//$('div.DTS_Loading', that.dom.scroller.parentNode).remove();

				//that.dom.table.style.position = "";
				//that.dom.table.style.top = "";
				//that.dom.table.style.left = "";
			//}
		//} );
	//},


	///**
	 //* Scrolling function - fired whenever the scrolling position is changed.
	 //* This method needs to use the stored values to see if the table should be
	 //* redrawn as we are moving towards the end of the information that is
	 //* currently drawn or not. If needed, then it will redraw the table based on
	 //* the new position.
	 //*  @returns {void}
	 //*  @private
	 //*/
	//"_fnScroll": function ()
	//{
		//var
			//that = this,
			//heights = this.s.heights,
			//iScrollTop = this.dom.scroller.scrollTop,
			//iTopRow;

		//if ( this.s.skip ) {
			//return;
		//}

		//if ( this.s.ingnoreScroll ) {
			//return;
		//}

		///* If the table has been sorted or filtered, then we use the redraw that
		 //* DataTables as done, rather than performing our own
		 //*/
		//if ( this.s.dt.bFiltered || this.s.dt.bSorted ) {
			//this.s.lastScrollTop = 0;
			//return;
		//}

		///* Update the table's information display for what is now in the viewport */
		//this._fnInfo();

		///* We don't want to state save on every scroll event - that's heavy
		 //* handed, so use a timeout to update the state saving only when the
		 //* scrolling has finished
		 //*/
		//clearTimeout( this.s.stateTO );
		//this.s.stateTO = setTimeout( function () {
			//that.s.dt.oApi._fnSaveState( that.s.dt );
		//}, 250 );

		///* Check if the scroll point is outside the trigger boundary which would required
		 //* a DataTables redraw
		 //*/
		//if ( iScrollTop < this.s.redrawTop || iScrollTop > this.s.redrawBottom ) {
			//var preRows = Math.ceil( ((this.s.displayBuffer-1)/2) * this.s.viewportRows );

			//if ( Math.abs( iScrollTop - this.s.lastScrollTop ) > heights.viewport || this.s.ani ) {
				//iTopRow = parseInt(this._domain( 'physicalToVirtual', iScrollTop ) / heights.row, 10) - preRows;
				//this.s.topRowFloat = (this._domain( 'physicalToVirtual', iScrollTop ) / heights.row);
			//}
			//else {
				//iTopRow = this.fnPixelsToRow( iScrollTop ) - preRows;
				//this.s.topRowFloat = this.fnPixelsToRow( iScrollTop, false );
			//}

			//if ( iTopRow <= 0 ) {
				///* At the start of the table */
				//iTopRow = 0;
			//}
			//else if ( iTopRow + this.s.dt._iDisplayLength > this.s.dt.fnRecordsDisplay() ) {
				///* At the end of the table */
				//iTopRow = this.s.dt.fnRecordsDisplay() - this.s.dt._iDisplayLength;
				//if ( iTopRow < 0 ) {
					//iTopRow = 0;
				//}
			//}
			//else if ( iTopRow % 2 !== 0 ) {
				//// For the row-striping classes (odd/even) we want only to start
				//// on evens otherwise the stripes will change between draws and
				//// look rubbish
				//iTopRow++;
			//}

			//if ( iTopRow != this.s.dt._iDisplayStart ) {
				///* Cache the new table position for quick lookups */
				//this.s.tableTop = $(this.s.dt.nTable).offset().top;
				//this.s.tableBottom = $(this.s.dt.nTable).height() + this.s.tableTop;

				//var draw =  function () {
					//if ( that.s.scrollDrawReq === null ) {
						//that.s.scrollDrawReq = iScrollTop;
					//}

					//that.s.dt._iDisplayStart = iTopRow;
					//if ( that.s.dt.oApi._fnCalculateEnd ) { // Removed in 1.10
						//that.s.dt.oApi._fnCalculateEnd( that.s.dt );
					//}
					//that.s.dt.oApi._fnDraw( that.s.dt );
				//};

				///* Do the DataTables redraw based on the calculated start point - note that when
				 //* using server-side processing we introduce a small delay to not DoS the server...
				 //*/
				//if ( this.s.dt.oFeatures.bServerSide ) {
					//clearTimeout( this.s.drawTO );
					//this.s.drawTO = setTimeout( draw, this.s.serverWait );
				//}
				//else {
					//draw();
				//}

				//if ( this.dom.loader && ! this.s.loaderVisible ) {
					//this.dom.loader.css( 'display', 'block' );
					//this.s.loaderVisible = true;
				//}
			//}
		//}

		//this.s.lastScrollTop = iScrollTop;
		//this.s.stateSaveThrottle();
	//},


	///**
	 //* Convert from one domain to another. The physical domain is the actual
	 //* pixel count on the screen, while the virtual is if we had browsers which
	 //* had scrolling containers of infinite height (i.e. the absolute value)
	 //*
	 //*  @param {string} dir Domain transform direction, `virtualToPhysical` or
	 //*    `physicalToVirtual` 
	 //*  @returns {number} Calculated transform
	 //*  @private
	 //*/
	//_domain: function ( dir, val )
	//{
		//var heights = this.s.heights;
		//var coeff;

		//// If the virtual and physical height match, then we use a linear
		//// transform between the two, allowing the scrollbar to be linear
		//if ( heights.virtual === heights.scroll ) {
			//coeff = (heights.virtual-heights.viewport) / (heights.scroll-heights.viewport);

			//if ( dir === 'virtualToPhysical' ) {
				//return val / coeff;
			//}
			//else if ( dir === 'physicalToVirtual' ) {
				//return val * coeff;
			//}
		//}

		//// Otherwise, we want a non-linear scrollbar to take account of the
		//// redrawing regions at the start and end of the table, otherwise these
		//// can stutter badly - on large tables 30px (for example) scroll might
		//// be hundreds of rows, so the table would be redrawing every few px at
		//// the start and end. Use a simple quadratic to stop this. It does mean
		//// the scrollbar is non-linear, but with such massive data sets, the
		//// scrollbar is going to be a best guess anyway
		//var xMax = (heights.scroll - heights.viewport) / 2;
		//var yMax = (heights.virtual - heights.viewport) / 2;

		//coeff = yMax / ( xMax * xMax );

		//if ( dir === 'virtualToPhysical' ) {
			//if ( val < yMax ) {
				//return Math.pow(val / coeff, 0.5);
			//}
			//else {
				//val = (yMax*2) - val;
				//return val < 0 ?
					//heights.scroll :
					//(xMax*2) - Math.pow(val / coeff, 0.5);
			//}
		//}
		//else if ( dir === 'physicalToVirtual' ) {
			//if ( val < xMax ) {
				//return val * val * coeff;
			//}
			//else {
				//val = (xMax*2) - val;
				//return val < 0 ?
					//heights.virtual :
					//(yMax*2) - (val * val * coeff);
			//}
		//}
	//},


	///**
	 //* Draw callback function which is fired when the DataTable is redrawn. The main function of
	 //* this method is to position the drawn table correctly the scrolling container for the rows
	 //* that is displays as a result of the scrolling position.
	 //*  @returns {void}
	 //*  @private
	 //*/
	//"_fnDrawCallback": function ()
	//{
		//var
			//that = this,
			//heights = this.s.heights,
			//iScrollTop = this.dom.scroller.scrollTop,
			//iActualScrollTop = iScrollTop,
			//iScrollBottom = iScrollTop + heights.viewport,
			//iTableHeight = $(this.s.dt.nTable).height(),
			//displayStart = this.s.dt._iDisplayStart,
			//displayLen = this.s.dt._iDisplayLength,
			//displayEnd = this.s.dt.fnRecordsDisplay();

		//// Disable the scroll event listener while we are updating the DOM
		//this.s.skip = true;

		//// Resize the scroll forcing element
		//this._fnScrollForce();

		//// Reposition the scrolling for the updated virtual position if needed
		//if ( displayStart === 0 ) {
			//// Linear calculation at the top of the table
			//iScrollTop = this.s.topRowFloat * heights.row;
		//}
		//else if ( displayStart + displayLen >= displayEnd ) {
			//// Linear calculation that the bottom as well
			//iScrollTop = heights.scroll - ((displayEnd - this.s.topRowFloat) * heights.row);
		//}
		//else {
			//// Domain scaled in the middle
			//iScrollTop = this._domain( 'virtualToPhysical', this.s.topRowFloat * heights.row );
		//}

		//this.dom.scroller.scrollTop = iScrollTop;

		//// Store positional information so positional calculations can be based
		//// upon the current table draw position
		//this.s.baseScrollTop = iScrollTop;
		//this.s.baseRowTop = this.s.topRowFloat;

		//// Position the table in the virtual scroller
		//var tableTop = iScrollTop - ((this.s.topRowFloat - displayStart) * heights.row);
		//if ( displayStart === 0 ) {
			//tableTop = 0;
		//}
		//else if ( displayStart + displayLen >= displayEnd ) {
			//tableTop = heights.scroll - iTableHeight;
		//}

		//this.dom.table.style.top = tableTop+'px';

		///* Cache some information for the scroller */
		//this.s.tableTop = tableTop;
		//this.s.tableBottom = iTableHeight + this.s.tableTop;

		//// Calculate the boundaries for where a redraw will be triggered by the
		//// scroll event listener
		//var boundaryPx = (iScrollTop - this.s.tableTop) * this.s.boundaryScale;
		//this.s.redrawTop = iScrollTop - boundaryPx;
		//this.s.redrawBottom = iScrollTop + boundaryPx;

		//this.s.skip = false;

		//// Restore the scrolling position that was saved by DataTable's state
		//// saving Note that this is done on the second draw when data is Ajax
		//// sourced, and the first draw when DOM soured
		//if ( this.s.dt.oFeatures.bStateSave && this.s.dt.oLoadedState !== null &&
			 //typeof this.s.dt.oLoadedState.iScroller != 'undefined' )
		//{
			//// A quirk of DataTables is that the draw callback will occur on an
			//// empty set if Ajax sourced, but not if server-side processing.
			//var ajaxSourced = (this.s.dt.sAjaxSource || that.s.dt.ajax) && ! this.s.dt.oFeatures.bServerSide ?
				//true :
				//false;

			//if ( ( ajaxSourced && this.s.dt.iDraw == 2) ||
			     //(!ajaxSourced && this.s.dt.iDraw == 1) )
			//{
				//setTimeout( function () {
					//$(that.dom.scroller).scrollTop( that.s.dt.oLoadedState.iScroller );
					//that.s.redrawTop = that.s.dt.oLoadedState.iScroller - (heights.viewport/2);

					//// In order to prevent layout thrashing we need another
					//// small delay
					//setTimeout( function () {
						//that.s.ingnoreScroll = false;
					//}, 0 );
				//}, 0 );
			//}
		//}
		//else {
			//that.s.ingnoreScroll = false;
		//}

		//// Because of the order of the DT callbacks, the info update will
		//// take precedence over the one we want here. So a 'thread' break is
		//// needed
		//setTimeout( function () {
			//that._fnInfo.call( that );
		//}, 0 );

		//// Hide the loading indicator
		//if ( this.dom.loader && this.s.loaderVisible ) {
			//this.dom.loader.css( 'display', 'none' );
			//this.s.loaderVisible = false;
		//}
	//},


	///**
	 //* Force the scrolling container to have height beyond that of just the
	 //* table that has been drawn so the user can scroll the whole data set.
	 //*
	 //* Note that if the calculated required scrolling height exceeds a maximum
	 //* value (1 million pixels - hard-coded) the forcing element will be set
	 //* only to that maximum value and virtual / physical domain transforms will
	 //* be used to allow Scroller to display tables of any number of records.
	 //*  @returns {void}
	 //*  @private
	 //*/
	//_fnScrollForce: function ()
	//{
		//var heights = this.s.heights;
		//var max = 1000000;

		//heights.virtual = heights.row * this.s.dt.fnRecordsDisplay();
		//heights.scroll = heights.virtual;

		//if ( heights.scroll > max ) {
			//heights.scroll = max;
		//}

		//this.dom.force.style.height = heights.scroll+"px";
	//},


	///**
	 //* Automatic calculation of table row height. This is just a little tricky here as using
	 //* initialisation DataTables has tale the table out of the document, so we need to create
	 //* a new table and insert it into the document, calculate the row height and then whip the
	 //* table out.
	 //*  @returns {void}
	 //*  @private
	 //*/
	//"_fnCalcRowHeight": function ()
	//{
		//var dt = this.s.dt;
		//var origTable = dt.nTable;
		//var nTable = origTable.cloneNode( false );
		//var tbody = $('<tbody/>').appendTo( nTable );
		//var container = $(
			//'<div class="'+dt.oClasses.sWrapper+' DTS">'+
				//'<div class="'+dt.oClasses.sScrollWrapper+'">'+
					//'<div class="'+dt.oClasses.sScrollBody+'"></div>'+
				//'</div>'+
			//'</div>'
		//);

		//// Want 3 rows in the sizing table so :first-child and :last-child
		//// CSS styles don't come into play - take the size of the middle row
		//$('tbody tr:lt(4)', origTable).clone().appendTo( tbody );
		//while( $('tr', tbody).length < 3 ) {
			//tbody.append( '<tr><td>&nbsp;</td></tr>' );
		//}

		//$('div.'+dt.oClasses.sScrollBody, container).append( nTable );

		//var appendTo;
		//if (dt._bInitComplete) {
			//appendTo = origTable.parentNode;
		//} else {
			//if (!this.s.dt.nHolding) {
				//this.s.dt.nHolding = $( '<div></div>' ).insertBefore( this.s.dt.nTable );
			//}
			//appendTo = this.s.dt.nHolding;
		//}

		//container.appendTo( appendTo );
		//this.s.heights.row = $('tr', tbody).eq(1).outerHeight();
		//container.remove();
	//},


	///**
	 //* Update any information elements that are controlled by the DataTable based on the scrolling
	 //* viewport and what rows are visible in it. This function basically acts in the same way as
	 //* _fnUpdateInfo in DataTables, and effectively replaces that function.
	 //*  @returns {void}
	 //*  @private
	 //*/
	//"_fnInfo": function ()
	//{
		//if ( !this.s.dt.oFeatures.bInfo )
		//{
			//return;
		//}

		//var
			//dt = this.s.dt,
			//language = dt.oLanguage,
			//iScrollTop = this.dom.scroller.scrollTop,
			//iStart = Math.floor( this.fnPixelsToRow(iScrollTop, false, this.s.ani)+1 ),
			//iMax = dt.fnRecordsTotal(),
			//iTotal = dt.fnRecordsDisplay(),
			//iPossibleEnd = Math.ceil( this.fnPixelsToRow(iScrollTop+this.s.heights.viewport, false, this.s.ani) ),
			//iEnd = iTotal < iPossibleEnd ? iTotal : iPossibleEnd,
			//sStart = dt.fnFormatNumber( iStart ),
			//sEnd = dt.fnFormatNumber( iEnd ),
			//sMax = dt.fnFormatNumber( iMax ),
			//sTotal = dt.fnFormatNumber( iTotal ),
			//sOut;

		//if ( dt.fnRecordsDisplay() === 0 &&
			   //dt.fnRecordsDisplay() == dt.fnRecordsTotal() )
		//{
			///* Empty record set */
			//sOut = language.sInfoEmpty+ language.sInfoPostFix;
		//}
		//else if ( dt.fnRecordsDisplay() === 0 )
		//{
			///* Empty record set after filtering */
			//sOut = language.sInfoEmpty +' '+
				//language.sInfoFiltered.replace('_MAX_', sMax)+
					//language.sInfoPostFix;
		//}
		//else if ( dt.fnRecordsDisplay() == dt.fnRecordsTotal() )
		//{
			///* Normal record set */
			//sOut = language.sInfo.
					//replace('_START_', sStart).
					//replace('_END_',   sEnd).
					//replace('_MAX_',   sMax).
					//replace('_TOTAL_', sTotal)+
				//language.sInfoPostFix;
		//}
		//else
		//{
			///* Record set after filtering */
			//sOut = language.sInfo.
					//replace('_START_', sStart).
					//replace('_END_',   sEnd).
					//replace('_MAX_',   sMax).
					//replace('_TOTAL_', sTotal) +' '+
				//language.sInfoFiltered.replace(
					//'_MAX_',
					//dt.fnFormatNumber(dt.fnRecordsTotal())
				//)+
				//language.sInfoPostFix;
		//}

		//var callback = language.fnInfoCallback;
		//if ( callback ) {
			//sOut = callback.call( dt.oInstance,
				//dt, iStart, iEnd, iMax, iTotal, sOut
			//);
		//}

		//var n = dt.aanFeatures.i;
		//if ( typeof n != 'undefined' )
		//{
			//for ( var i=0, iLen=n.length ; i<iLen ; i++ )
			//{
				//$(n[i]).html( sOut );
			//}
		//}
	//}
//};



///* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 //* Statics
 //* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


///**
 //* Scroller default settings for initialisation
 //*  @namespace
 //*  @name Scroller.defaults
 //*  @static
 //*/
//Scroller.defaults = /** @lends Scroller.defaults */{
	///**
	 //* Indicate if Scroller show show trace information on the console or not. This can be
	 //* useful when debugging Scroller or if just curious as to what it is doing, but should
	 //* be turned off for production.
	 //*  @type     bool
	 //*  @default  false
	 //*  @static
	 //*  @example
	 //*    var oTable = $('#example').dataTable( {
	 //*        "sScrollY": "200px",
	 //*        "sDom": "frtiS",
	 //*        "bDeferRender": true,
	 //*        "oScroller": {
	 //*          "trace": true
	 //*        }
	 //*    } );
	 //*/
	//"trace": false,

	///**
	 //* Scroller will attempt to automatically calculate the height of rows for it's internal
	 //* calculations. However the height that is used can be overridden using this parameter.
	 //*  @type     int|string
	 //*  @default  auto
	 //*  @static
	 //*  @example
	 //*    var oTable = $('#example').dataTable( {
	 //*        "sScrollY": "200px",
	 //*        "sDom": "frtiS",
	 //*        "bDeferRender": true,
	 //*        "oScroller": {
	 //*          "rowHeight": 30
	 //*        }
	 //*    } );
	 //*/
	//"rowHeight": "auto",

	///**
	 //* When using server-side processing, Scroller will wait a small amount of time to allow
	 //* the scrolling to finish before requesting more data from the server. This prevents
	 //* you from DoSing your own server! The wait time can be configured by this parameter.
	 //*  @type     int
	 //*  @default  200
	 //*  @static
	 //*  @example
	 //*    var oTable = $('#example').dataTable( {
	 //*        "sScrollY": "200px",
	 //*        "sDom": "frtiS",
	 //*        "bDeferRender": true,
	 //*        "oScroller": {
	 //*          "serverWait": 100
	 //*        }
	 //*    } );
	 //*/
	//"serverWait": 200,

	///**
	 //* The display buffer is what Scroller uses to calculate how many rows it should pre-fetch
	 //* for scrolling. Scroller automatically adjusts DataTables' display length to pre-fetch
	 //* rows that will be shown in "near scrolling" (i.e. just beyond the current display area).
	 //* The value is based upon the number of rows that can be displayed in the viewport (i.e.
	 //* a value of 1), and will apply the display range to records before before and after the
	 //* current viewport - i.e. a factor of 3 will allow Scroller to pre-fetch 1 viewport's worth
	 //* of rows before the current viewport, the current viewport's rows and 1 viewport's worth
	 //* of rows after the current viewport. Adjusting this value can be useful for ensuring
	 //* smooth scrolling based on your data set.
	 //*  @type     int
	 //*  @default  7
	 //*  @static
	 //*  @example
	 //*    var oTable = $('#example').dataTable( {
	 //*        "sScrollY": "200px",
	 //*        "sDom": "frtiS",
	 //*        "bDeferRender": true,
	 //*        "oScroller": {
	 //*          "displayBuffer": 10
	 //*        }
	 //*    } );
	 //*/
	//"displayBuffer": 9,

	///**
	 //* Scroller uses the boundary scaling factor to decide when to redraw the table - which it
	 //* typically does before you reach the end of the currently loaded data set (in order to
	 //* allow the data to look continuous to a user scrolling through the data). If given as 0
	 //* then the table will be redrawn whenever the viewport is scrolled, while 1 would not
	 //* redraw the table until the currently loaded data has all been shown. You will want
	 //* something in the middle - the default factor of 0.5 is usually suitable.
	 //*  @type     float
	 //*  @default  0.5
	 //*  @static
	 //*  @example
	 //*    var oTable = $('#example').dataTable( {
	 //*        "sScrollY": "200px",
	 //*        "sDom": "frtiS",
	 //*        "bDeferRender": true,
	 //*        "oScroller": {
	 //*          "boundaryScale": 0.75
	 //*        }
	 //*    } );
	 //*/
	//"boundaryScale": 0.5,

	///**
	 //* Show (or not) the loading element in the background of the table. Note that you should
	 //* include the dataTables.scroller.css file for this to be displayed correctly.
	 //*  @type     boolean
	 //*  @default  false
	 //*  @static
	 //*  @example
	 //*    var oTable = $('#example').dataTable( {
	 //*        "sScrollY": "200px",
	 //*        "sDom": "frtiS",
	 //*        "bDeferRender": true,
	 //*        "oScroller": {
	 //*          "loadingIndicator": true
	 //*        }
	 //*    } );
	 //*/
	//"loadingIndicator": false
//};

//Scroller.oDefaults = Scroller.defaults;



///* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 //* Constants
 //* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

///**
 //* Scroller version
 //*  @type      String
 //*  @default   See code
 //*  @name      Scroller.version
 //*  @static
 //*/
//Scroller.version = "1.2.2";



///* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 //* Initialisation
 //* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

///*
 //* Register a new feature with DataTables
 //*/
//if ( typeof $.fn.dataTable == "function" &&
     //typeof $.fn.dataTableExt.fnVersionCheck == "function" &&
     //$.fn.dataTableExt.fnVersionCheck('1.9.0') )
//{
	//$.fn.dataTableExt.aoFeatures.push( {
		//"fnInit": function( oDTSettings ) {
			//var init = oDTSettings.oInit;
			//var opts = init.scroller || init.oScroller || {};
			//var oScroller = new Scroller( oDTSettings, opts );
			//return oScroller.dom.wrapper;
		//},
		//"cFeature": "S",
		//"sFeature": "Scroller"
	//} );
//}
//else
//{
	//alert( "Warning: Scroller requires DataTables 1.9.0 or greater - www.datatables.net/download");
//}


//// Attach Scroller to DataTables so it can be accessed as an 'extra'
//$.fn.dataTable.Scroller = Scroller;
//$.fn.DataTable.Scroller = Scroller;


//// DataTables 1.10 API method aliases
//if ( $.fn.dataTable.Api ) {
	//var Api = $.fn.dataTable.Api;

	//Api.register( 'scroller()', function () {
		//return this;
	//} );

	//Api.register( 'scroller().rowToPixels()', function ( rowIdx, intParse, virtual ) {
		//var ctx = this.context;

		//if ( ctx.length && ctx[0].oScroller ) {
			//return ctx[0].oScroller.fnRowToPixels( rowIdx, intParse, virtual );
		//}
		//// undefined
	//} );

	//Api.register( 'scroller().pixelsToRow()', function ( pixels, intParse, virtual ) {
		//var ctx = this.context;

		//if ( ctx.length && ctx[0].oScroller ) {
			//return ctx[0].oScroller.fnPixelsToRow( pixels, intParse, virtual );
		//}
		//// undefined
	//} );

	//Api.register( 'scroller().scrollToRow()', function ( row, ani ) {
		//this.iterator( 'table', function ( ctx ) {
			//if ( ctx.oScroller ) {
				//ctx.oScroller.fnScrollToRow( row, ani );
			//}
		//} );

		//return this;
	//} );

	//Api.register( 'scroller().measure()', function ( redraw ) {
		//this.iterator( 'table', function ( ctx ) {
			//if ( ctx.oScroller ) {
				//ctx.oScroller.fnMeasure( redraw );
			//}
		//} );

		//return this;
	//} );
//}


//return Scroller;
//}; // /factory


//// Define as an AMD module if possible
//if ( typeof define === 'function' && define.amd ) {
	//define( ['jquery', 'datatables'], factory );
//}
//else if ( typeof exports === 'object' ) {
    //// Node/CommonJS
    //factory( require('jquery'), require('datatables') );
//}
//else if ( jQuery && !jQuery.fn.dataTable.Scroller ) {
	//// Otherwise simply initialise as normal, stopping multiple evaluation
	//factory( jQuery, jQuery.fn.dataTable );
//}


//})(window, document);


///bibmas using datatables extension/plugin 

/*! ColVis 1.1.2
 * ©2010-2015 SpryMedia Ltd - datatables.net/license
 */

/**
 * @summary     ColVis
 * @description Controls for column visibility in DataTables
 * @version     1.1.2
 * @file        dataTables.colReorder.js
 * @author      SpryMedia Ltd (www.sprymedia.co.uk)
 * @contact     www.sprymedia.co.uk/contact
 * @copyright   Copyright 2010-2015 SpryMedia Ltd.
 *
 * This source file is free software, available under the following license:
 *   MIT license - http://datatables.net/license/mit
 *
 * This source file is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the license files for details.
 *
 * For details please refer to: http://www.datatables.net
 */

(function(window, document, undefined) {


var factory = function( $, DataTable ) {
"use strict";

/**
 * ColVis provides column visibility control for DataTables
 *
 * @class ColVis
 * @constructor
 * @param {object} DataTables settings object. With DataTables 1.10 this can
 *   also be and API instance, table node, jQuery collection or jQuery selector.
 * @param {object} ColVis configuration options
 */
var ColVis = function( oDTSettings, oInit )
{
	/* Santiy check that we are a new instance */
	if ( !this.CLASS || this.CLASS != "ColVis" )
	{
		alert( "Warning: ColVis must be initialised with the keyword 'new'" );
	}

	if ( typeof oInit == 'undefined' )
	{
		oInit = {};
	}

	var camelToHungarian = $.fn.dataTable.camelToHungarian;
	if ( camelToHungarian ) {
		camelToHungarian( ColVis.defaults, ColVis.defaults, true );
		camelToHungarian( ColVis.defaults, oInit );
	}


	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 * Public class variables
	 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

	/**
	 * @namespace Settings object which contains customisable information for
	 *     ColVis instance. Augmented by ColVis.defaults
	 */
	this.s = {
		/**
		 * DataTables settings object
		 *  @property dt
		 *  @type     Object
		 *  @default  null
		 */
		"dt": null,

		/**
		 * Customisation object
		 *  @property oInit
		 *  @type     Object
		 *  @default  passed in
		 */
		"oInit": oInit,

		/**
		 * Flag to say if the collection is hidden
		 *  @property hidden
		 *  @type     boolean
		 *  @default  true
		 */
		"hidden": true,

		/**
		 * Store the original visibility settings so they could be restored
		 *  @property abOriginal
		 *  @type     Array
		 *  @default  []
		 */
		"abOriginal": []
	};


	/**
	 * @namespace Common and useful DOM elements for the class instance
	 */
	this.dom = {
		/**
		 * Wrapper for the button - given back to DataTables as the node to insert
		 *  @property wrapper
		 *  @type     Node
		 *  @default  null
		 */
		"wrapper": null,

		/**
		 * Activation button
		 *  @property button
		 *  @type     Node
		 *  @default  null
		 */
		"button": null,

		/**
		 * Collection list node
		 *  @property collection
		 *  @type     Node
		 *  @default  null
		 */
		"collection": null,

		/**
		 * Background node used for shading the display and event capturing
		 *  @property background
		 *  @type     Node
		 *  @default  null
		 */
		"background": null,

		/**
		 * Element to position over the activation button to catch mouse events when using mouseover
		 *  @property catcher
		 *  @type     Node
		 *  @default  null
		 */
		"catcher": null,

		/**
		 * List of button elements
		 *  @property buttons
		 *  @type     Array
		 *  @default  []
		 */
		"buttons": [],

		/**
		 * List of group button elements
		 *  @property groupButtons
		 *  @type     Array
		 *  @default  []
		 */
		"groupButtons": [],

		/**
		 * Restore button
		 *  @property restore
		 *  @type     Node
		 *  @default  null
		 */
		"restore": null
	};

	/* Store global reference */
	ColVis.aInstances.push( this );

	/* Constructor logic */
	this.s.dt = $.fn.dataTable.Api ?
		new $.fn.dataTable.Api( oDTSettings ).settings()[0] :
		oDTSettings;

	this._fnConstruct( oInit );
	return this;
};



ColVis.prototype = {
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 * Public methods
	 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

	/**
	 * Get the ColVis instance's control button so it can be injected into the
	 * DOM
	 *  @method  button
	 *  @returns {node} ColVis button
	 */
	button: function ()
	{
		return this.dom.wrapper;
	},

	/**
	 * Alias of `rebuild` for backwards compatibility
	 *  @method  fnRebuild
	 */
	"fnRebuild": function ()
	{
		this.rebuild();
	},

	/**
	 * Rebuild the list of buttons for this instance (i.e. if there is a column
	 * header update)
	 *  @method  fnRebuild
	 */
	rebuild: function ()
	{
		/* Remove the old buttons */
		for ( var i=this.dom.buttons.length-1 ; i>=0 ; i-- ) {
			this.dom.collection.removeChild( this.dom.buttons[i] );
		}
		this.dom.buttons.splice( 0, this.dom.buttons.length );
		this.dom.groupButtons.splice(0, this.dom.groupButtons.length);

		if ( this.dom.restore ) {
			this.dom.restore.parentNode( this.dom.restore );
		}

		/* Re-add them (this is not the optimal way of doing this, it is fast and effective) */
		this._fnAddGroups();
		this._fnAddButtons();

		/* Update the checkboxes */
		this._fnDrawCallback();
	},


	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 * Private methods (they are of course public in JS, but recommended as private)
	 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

	/**
	 * Constructor logic
	 *  @method  _fnConstruct
	 *  @returns void
	 *  @private
	 */
	"_fnConstruct": function ( init )
	{
		this._fnApplyCustomisation( init );

		var that = this;
		var i, iLen;
		this.dom.wrapper = document.createElement('div');
		this.dom.wrapper.className = "ColVis";

		var mylabel= $("<label>\u2325 Show / hide <\/label>").appendTo( this.dom.wrapper )[0]; //// as 2014/2015 bibmas 
		
		this.dom.button = $( '<button />', {
				'class': !this.s.dt.bJUI ?
					"ColVis_Button ColVis_MasterButton" :
					"ColVis_Button ColVis_MasterButton ui-button ui-state-default"
			} )
			.append( '<span>'+this.s.buttonText+'</span>' )
			.bind( this.s.activate=="mouseover" ? "mouseover" : "click", function (e) {
				e.preventDefault();
				that._fnCollectionShow();
			} )
			.appendTo( mylabel ); //// as 2014/2015 bibmas  //formerly: .appendTo( this.dom.wrapper )[0];   

		this.dom.catcher = this._fnDomCatcher();
		this.dom.collection = this._fnDomCollection();
		this.dom.background = this._fnDomBackground();

		this._fnAddGroups();
		this._fnAddButtons();

		/* Store the original visibility information */
		for ( i=0, iLen=this.s.dt.aoColumns.length ; i<iLen ; i++ )
		{
			this.s.abOriginal.push( this.s.dt.aoColumns[i].bVisible );
		}

		/* Update on each draw */
		this.s.dt.aoDrawCallback.push( {
			"fn": function () {
				that._fnDrawCallback.call( that );
			},
			"sName": "ColVis"
		} );

		/* If columns are reordered, then we need to update our exclude list and
		 * rebuild the displayed list
		 */
		$(this.s.dt.oInstance).bind( 'column-reorder.dt', function ( e, oSettings, oReorder ) {
			for ( i=0, iLen=that.s.aiExclude.length ; i<iLen ; i++ ) {
				that.s.aiExclude[i] = oReorder.aiInvertMapping[ that.s.aiExclude[i] ];
			}

			var mStore = that.s.abOriginal.splice( oReorder.iFrom, 1 )[0];
			that.s.abOriginal.splice( oReorder.iTo, 0, mStore );

			that.fnRebuild();
		} );

		$(this.s.dt.oInstance).bind( 'destroy.dt', function () {
			$(that.dom.wrapper).remove();
		} );

		// Set the initial state
		this._fnDrawCallback();
	},


	/**
	 * Apply any customisation to the settings from the DataTables initialisation
	 *  @method  _fnApplyCustomisation
	 *  @returns void
	 *  @private
	 */
	"_fnApplyCustomisation": function ( init )
	{
		$.extend( true, this.s, ColVis.defaults, init );

		// Slightly messy overlap for the camelCase notation
		if ( ! this.s.showAll && this.s.bShowAll ) {
			this.s.showAll = this.s.sShowAll;
		}

		if ( ! this.s.restore && this.s.bRestore ) {
			this.s.restore = this.s.sRestore;
		}

		// CamelCase to Hungarian for the column groups 
		var groups = this.s.groups;
		var hungarianGroups = this.s.aoGroups;
		if ( groups ) {
			for ( var i=0, ien=groups.length ; i<ien ; i++ ) {
				if ( groups[i].title ) {
					hungarianGroups[i].sTitle = groups[i].title;
				}
				if ( groups[i].columns ) {
					hungarianGroups[i].aiColumns = groups[i].columns;
				}
			}
		}
	},


	/**
	 * On each table draw, check the visibility checkboxes as needed. This allows any process to
	 * update the table's column visibility and ColVis will still be accurate.
	 *  @method  _fnDrawCallback
	 *  @returns void
	 *  @private
	 */
	"_fnDrawCallback": function ()
	{
		var columns = this.s.dt.aoColumns;
		var buttons = this.dom.buttons;
		var groups = this.s.aoGroups;
		var button;

		for ( var i=0, ien=buttons.length ; i<ien ; i++ ) {
			button = buttons[i];

			if ( button.__columnIdx !== undefined ) {
				$('input', button).prop( 'checked', columns[ button.__columnIdx ].bVisible );
			}
		}

		var allVisible = function ( columnIndeces ) {
			for ( var k=0, kLen=columnIndeces.length ; k<kLen ; k++ )
			{
				if (  columns[columnIndeces[k]].bVisible === false ) { return false; }
			}
			return true;
		};
		var allHidden = function ( columnIndeces ) {
			for ( var m=0 , mLen=columnIndeces.length ; m<mLen ; m++ )
			{
				if ( columns[columnIndeces[m]].bVisible === true ) { return false; }
			}
			return true;
		};

		for ( var j=0, jLen=groups.length ; j<jLen ; j++ )
		{
			if ( allVisible(groups[j].aiColumns) )
			{
				$('input', this.dom.groupButtons[j]).prop('checked', true);
				$('input', this.dom.groupButtons[j]).prop('indeterminate', false);
			}
			else if ( allHidden(groups[j].aiColumns) )
			{
				$('input', this.dom.groupButtons[j]).prop('checked', false);
				$('input', this.dom.groupButtons[j]).prop('indeterminate', false);
			}
			else
			{
				$('input', this.dom.groupButtons[j]).prop('indeterminate', true);
			}
		}
	},


	/**
	 * Loop through the groups (provided in the settings) and create a button for each.
	 *  @method  _fnAddgroups
	 *  @returns void
	 *  @private
	 */
	"_fnAddGroups": function ()
	{
		var nButton;

		if ( typeof this.s.aoGroups != 'undefined' )
		{
			for ( var i=0, iLen=this.s.aoGroups.length ; i<iLen ; i++ )
			{
				nButton = this._fnDomGroupButton( i );
				this.dom.groupButtons.push( nButton );
				this.dom.buttons.push( nButton );
				this.dom.collection.appendChild( nButton );
			}
		}
	},


	/**
	 * Loop through the columns in the table and as a new button for each one.
	 *  @method  _fnAddButtons
	 *  @returns void
	 *  @private
	 */
	"_fnAddButtons": function ()
	{
		var
			nButton,
			columns = this.s.dt.aoColumns;

		if ( $.inArray( 'all', this.s.aiExclude ) === -1 ) {
			for ( var i=0, iLen=columns.length ; i<iLen ; i++ )
			{
				if ( $.inArray( i, this.s.aiExclude ) === -1 )
				{
					nButton = this._fnDomColumnButton( i );
					nButton.__columnIdx = i;
					this.dom.buttons.push( nButton );
				}
			}
		}

		if ( this.s.order === 'alpha' ) {
			this.dom.buttons.sort( function ( a, b ) {
				var titleA = columns[ a.__columnIdx ].sTitle;
				var titleB = columns[ b.__columnIdx ].sTitle;

				return titleA === titleB ?
					0 :
					titleA < titleB ?
						-1 :
						1;
			} );
		}

		if ( this.s.restore )
		{
			nButton = this._fnDomRestoreButton();
			nButton.className += " ColVis_Restore";
			this.dom.buttons.push( nButton );
		}

		if ( this.s.showAll )
		{
			nButton = this._fnDomShowXButton( this.s.showAll, true );
			nButton.className += " ColVis_ShowAll";
			this.dom.buttons.push( nButton );
		}

		if ( this.s.showNone )
		{
			nButton = this._fnDomShowXButton( this.s.showNone, false );
			nButton.className += " ColVis_ShowNone";
			this.dom.buttons.push( nButton );
		}

		$(this.dom.collection).append( this.dom.buttons );
	},


	/**
	 * Create a button which allows a "restore" action
	 *  @method  _fnDomRestoreButton
	 *  @returns {Node} Created button
	 *  @private
	 */
	"_fnDomRestoreButton": function ()
	{
		var
			that = this,
			dt = this.s.dt;

		return $(
				'<li class="ColVis_Special '+(dt.bJUI ? 'ui-button ui-state-default' : '')+'">'+
					this.s.restore+
				'</li>'
			)
			.click( function (e) {
				for ( var i=0, iLen=that.s.abOriginal.length ; i<iLen ; i++ )
				{
					that.s.dt.oInstance.fnSetColumnVis( i, that.s.abOriginal[i], false );
				}
				that._fnAdjustOpenRows();
				that.s.dt.oInstance.fnAdjustColumnSizing( false );
				that.s.dt.oInstance.fnDraw( false );
			} )[0];
	},


	/**
	 * Create a button which allows show all and show node actions
	 *  @method  _fnDomShowXButton
	 *  @returns {Node} Created button
	 *  @private
	 */
	"_fnDomShowXButton": function ( str, action )
	{
		var
			that = this,
			dt = this.s.dt;

		return $(
				'<li class="ColVis_Special '+(dt.bJUI ? 'ui-button ui-state-default' : '')+'">'+
					str+
				'</li>'
			)
			.click( function (e) {
				for ( var i=0, iLen=that.s.abOriginal.length ; i<iLen ; i++ )
				{
					if (that.s.aiExclude.indexOf(i) === -1)
					{
						that.s.dt.oInstance.fnSetColumnVis( i, action, false );
					}
				}
				that._fnAdjustOpenRows();
				that.s.dt.oInstance.fnAdjustColumnSizing( false );
				that.s.dt.oInstance.fnDraw( false );
			} )[0];
	},


	/**
	 * Create the DOM for a show / hide group button
	 *  @method  _fnDomGroupButton
	 *  @param {int} i Group in question, order based on that provided in settings
	 *  @returns {Node} Created button
	 *  @private
	 */
	"_fnDomGroupButton": function ( i )
	{
		var
			that = this,
			dt = this.s.dt,
			oGroup = this.s.aoGroups[i];

		return $(
				'<li class="ColVis_Special '+(dt.bJUI ? 'ui-button ui-state-default' : '')+'">'+
					'<label>'+
						'<input type="checkbox" />'+
						'<span>'+oGroup.sTitle+'</span>'+
					'</label>'+
				'</li>'
			)
			.click( function (e) {
				var showHide = !$('input', this).is(":checked");
				if (  e.target.nodeName.toLowerCase() !== "li" )
				{
					showHide = ! showHide;
				}

				for ( var j=0 ; j < oGroup.aiColumns.length ; j++ )
				{
					that.s.dt.oInstance.fnSetColumnVis( oGroup.aiColumns[j], showHide );
				}
			} )[0];
	},


	/**
	 * Create the DOM for a show / hide button
	 *  @method  _fnDomColumnButton
	 *  @param {int} i Column in question
	 *  @returns {Node} Created button
	 *  @private
	 */
	"_fnDomColumnButton": function ( i )
	{
		var
			that = this,
			column = this.s.dt.aoColumns[i],
			dt = this.s.dt;

		var title = this.s.fnLabel===null ?
			column.sTitle :
			this.s.fnLabel( i, column.sTitle, column.nTh );

		return $(
				'<li '+(dt.bJUI ? 'class="ui-button ui-state-default"' : '')+'>'+
					'<label>'+
						'<input type="checkbox" />'+
						'<span>'+title+'</span>'+
					'</label>'+
				'</li>'
			)
			.click( function (e) {
				var showHide = !$('input', this).is(":checked");
				if (  e.target.nodeName.toLowerCase() !== "li" )
				{
					if ( e.target.nodeName.toLowerCase() == "input" || that.s.fnStateChange === null )
					{
						showHide = ! showHide;
					}
				}

				/* Need to consider the case where the initialiser created more than one table - change the
				 * API index that DataTables is using
				 */
				var oldIndex = $.fn.dataTableExt.iApiIndex;
				$.fn.dataTableExt.iApiIndex = that._fnDataTablesApiIndex.call(that);

				// Optimisation for server-side processing when scrolling - don't do a full redraw
				if ( dt.oFeatures.bServerSide )
				{
					that.s.dt.oInstance.fnSetColumnVis( i, showHide, false );
					that.s.dt.oInstance.fnAdjustColumnSizing( false );
					if (dt.oScroll.sX !== "" || dt.oScroll.sY !== "" )
					{
						that.s.dt.oInstance.oApi._fnScrollDraw( that.s.dt );
					}
					that._fnDrawCallback();
				}
				else
				{
					that.s.dt.oInstance.fnSetColumnVis( i, showHide );
				}

				$.fn.dataTableExt.iApiIndex = oldIndex; /* Restore */

				if ( that.s.fnStateChange !== null )
				{
					if ( e.target.nodeName.toLowerCase() == "span" )
					{
						e.preventDefault();
					}
					that.s.fnStateChange.call( that, i, showHide );
				}
			} )[0];
	},


	/**
	 * Get the position in the DataTables instance array of the table for this
	 * instance of ColVis
	 *  @method  _fnDataTablesApiIndex
	 *  @returns {int} Index
	 *  @private
	 */
	"_fnDataTablesApiIndex": function ()
	{
		for ( var i=0, iLen=this.s.dt.oInstance.length ; i<iLen ; i++ )
		{
			if ( this.s.dt.oInstance[i] == this.s.dt.nTable )
			{
				return i;
			}
		}
		return 0;
	},


	/**
	 * Create the element used to contain list the columns (it is shown and
	 * hidden as needed)
	 *  @method  _fnDomCollection
	 *  @returns {Node} div container for the collection
	 *  @private
	 */
	"_fnDomCollection": function ()
	{
		return $('<ul />', {
				'class': !this.s.dt.bJUI ?
					"ColVis_collection" :
					"ColVis_collection ui-buttonset ui-buttonset-multi"
			} )
		.css( {
			'display': 'none',
			'opacity': 0,
			'position': ! this.s.bCssPosition ?
				'absolute' :
				''
		} )[0];
	},


	/**
	 * An element to be placed on top of the activate button to catch events
	 *  @method  _fnDomCatcher
	 *  @returns {Node} div container for the collection
	 *  @private
	 */
	"_fnDomCatcher": function ()
	{
		var
			that = this,
			nCatcher = document.createElement('div');
		nCatcher.className = "ColVis_catcher";

		$(nCatcher).click( function () {
			that._fnCollectionHide.call( that, null, null );
		} );

		return nCatcher;
	},


	/**
	 * Create the element used to shade the background, and capture hide events (it is shown and
	 * hidden as needed)
	 *  @method  _fnDomBackground
	 *  @returns {Node} div container for the background
	 *  @private
	 */
	"_fnDomBackground": function ()
	{
		var that = this;

		var background = $('<div></div>')
			.addClass( 'ColVis_collectionBackground' )
			.css( 'opacity', 0 )
			.click( function () {
				that._fnCollectionHide.call( that, null, null );
			} );

		/* When considering a mouse over action for the activation, we also consider a mouse out
		 * which is the same as a mouse over the background - without all the messing around of
		 * bubbling events. Use the catcher element to avoid messing around with bubbling
		 */
		if ( this.s.activate == "mouseover" )
		{
			background.mouseover( function () {
				that.s.overcollection = false;
				that._fnCollectionHide.call( that, null, null );
			} );
		}

		return background[0];
	},


	/**
	 * Show the show / hide list and the background
	 *  @method  _fnCollectionShow
	 *  @returns void
	 *  @private
	 */
	"_fnCollectionShow": function ()
	{
		var that = this, i, iLen, iLeft;
		var oPos = $(this.dom.button).offset();
		var nHidden = this.dom.collection;
		var nBackground = this.dom.background;
		var iDivX = parseInt(oPos.left, 10);
		var iDivY = parseInt(oPos.top + $(this.dom.button).outerHeight(), 10);

		if ( ! this.s.bCssPosition )
		{
			nHidden.style.top = iDivY+"px";
			nHidden.style.left = iDivX+"px";
		}

		$(nHidden).css( {
			'display': 'block',
			'opacity': 0
		} );

		nBackground.style.bottom ='0px';
		nBackground.style.right = '0px';

		var oStyle = this.dom.catcher.style;
		oStyle.height = $(this.dom.button).outerHeight()+"px";
		oStyle.width = $(this.dom.button).outerWidth()+"px";
		oStyle.top = oPos.top+"px";
		oStyle.left = iDivX+"px";

		document.body.appendChild( nBackground );
		document.body.appendChild( nHidden );
		document.body.appendChild( this.dom.catcher );

		/* This results in a very small delay for the end user but it allows the animation to be
		 * much smoother. If you don't want the animation, then the setTimeout can be removed
		 */
		$(nHidden).animate({"opacity": 1}, that.s.iOverlayFade);
		$(nBackground).animate({"opacity": 0.1}, that.s.iOverlayFade, 'linear', function () {
			/* In IE6 if you set the checked attribute of a hidden checkbox, then this is not visually
			 * reflected. As such, we need to do it here, once it is visible. Unbelievable.
			 */
			if ( $.browser && $.browser.msie && $.browser.version == "6.0" )
			{
				that._fnDrawCallback();
			}
		});

		/* Visual corrections to try and keep the collection visible */
		if ( !this.s.bCssPosition )
		{
			iLeft = ( this.s.sAlign=="left" ) ?
				iDivX :
				iDivX - $(nHidden).outerWidth() + $(this.dom.button).outerWidth();

			nHidden.style.left = iLeft+"px";

			var iDivWidth = $(nHidden).outerWidth();
			var iDivHeight = $(nHidden).outerHeight();
			var iDocWidth = $(document).width();

			if ( iLeft + iDivWidth > iDocWidth )
			{
				nHidden.style.left = (iDocWidth-iDivWidth)+"px";
			}
		}

		this.s.hidden = false;
	},


	/**
	 * Hide the show / hide list and the background
	 *  @method  _fnCollectionHide
	 *  @returns void
	 *  @private
	 */
	"_fnCollectionHide": function (  )
	{
		var that = this;

		if ( !this.s.hidden && this.dom.collection !== null )
		{
			this.s.hidden = true;

			$(this.dom.collection).animate({"opacity": 0}, that.s.iOverlayFade, function (e) {
				this.style.display = "none";
			} );

			$(this.dom.background).animate({"opacity": 0}, that.s.iOverlayFade, function (e) {
				document.body.removeChild( that.dom.background );
				document.body.removeChild( that.dom.catcher );
			} );
		}
	},


	/**
	 * Alter the colspan on any fnOpen rows
	 */
	"_fnAdjustOpenRows": function ()
	{
		var aoOpen = this.s.dt.aoOpenRows;
		var iVisible = this.s.dt.oApi._fnVisbleColumns( this.s.dt );

		for ( var i=0, iLen=aoOpen.length ; i<iLen ; i++ ) {
			aoOpen[i].nTr.getElementsByTagName('td')[0].colSpan = iVisible;
		}
	}
};





/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Static object methods
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/**
 * Rebuild the collection for a given table, or all tables if no parameter given
 *  @method  ColVis.fnRebuild
 *  @static
 *  @param   object oTable DataTable instance to consider - optional
 *  @returns void
 */
ColVis.fnRebuild = function ( oTable )
{
	var nTable = null;
	if ( typeof oTable != 'undefined' )
	{
		nTable = $.fn.dataTable.Api ?
			new $.fn.dataTable.Api( oTable ).table().node() :
			oTable.fnSettings().nTable;
	}

	for ( var i=0, iLen=ColVis.aInstances.length ; i<iLen ; i++ )
	{
		if ( typeof oTable == 'undefined' || nTable == ColVis.aInstances[i].s.dt.nTable )
		{
			ColVis.aInstances[i].fnRebuild();
		}
	}
};


ColVis.defaults = {
	/**
	 * Mode of activation. Can be 'click' or 'mouseover'
	 *  @property activate
	 *  @type     string
	 *  @default  click
	 */
	active: 'click',

	/**
	 * Text used for the button
	 *  @property buttonText
	 *  @type     string
	 *  @default  Show / hide columns
	 */
	buttonText: '\u2630 columns',

	/**
	 * List of columns (integers) which should be excluded from the list
	 *  @property aiExclude
	 *  @type     array
	 *  @default  []
	 */
	aiExclude: [d4t4c3ll1nd3x], //// as 2014/2015 bibmas 

	/**
	 * Show restore button
	 *  @property bRestore
	 *  @type     boolean
	 *  @default  false
	 */
	bRestore: false,

	/**
	 * Restore button text
	 *  @property sRestore
	 *  @type     string
	 *  @default  Restore original
	 */
	sRestore: 'Restore original',

	/**
	 * Show Show-All button
	 *  @property bShowAll
	 *  @type     boolean
	 *  @default  false
	 */
	bShowAll: false,

	/**
	 * Show All button text
	 *  @property sShowAll
	 *  @type     string
	 *  @default  Restore original
	 */
	sShowAll: 'Show All',

	/**
	 * Position of the collection menu when shown - align "left" or "right"
	 *  @property sAlign
	 *  @type     string
	 *  @default  left
	 */
	sAlign: 'left',

	/**
	 * Callback function to tell the user when the state has changed
	 *  @property fnStateChange
	 *  @type     function
	 *  @default  null
	 */
	fnStateChange: null,

	/**
	 * Overlay animation duration in mS
	 *  @property iOverlayFade
	 *  @type     integer|false
	 *  @default  500
	 */
	iOverlayFade: 500,

	/**
	 * Label callback for column names. Takes three parameters: 1. the
	 * column index, 2. the column title detected by DataTables and 3. the
	 * TH node for the column
	 *  @property fnLabel
	 *  @type     function
	 *  @default  null
	 */
	fnLabel: null,

	/**
	 * Indicate if the column list should be positioned by Javascript,
	 * visually below the button or allow CSS to do the positioning
	 *  @property bCssPosition
	 *  @type     boolean
	 *  @default  false
	 */
	bCssPosition: false,

	/**
	 * Group buttons
	 *  @property aoGroups
	 *  @type     array
	 *  @default  []
	 */
	aoGroups: [],

	/**
	 * Button ordering - 'alpha' (alphabetical) or 'column' (table column
	 * order)
	 *  @property order
	 *  @type     string
	 *  @default  column
	 */
	order: 'column'
};



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Static object properties
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/**
 * Collection of all ColVis instances
 *  @property ColVis.aInstances
 *  @static
 *  @type     Array
 *  @default  []
 */
ColVis.aInstances = [];





/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Constants
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/**
 * Name of this class
 *  @constant CLASS
 *  @type     String
 *  @default  ColVis
 */
ColVis.prototype.CLASS = "ColVis";


/**
 * ColVis version
 *  @constant  VERSION
 *  @type      String
 *  @default   See code
 */
ColVis.VERSION = "1.1.2";
ColVis.prototype.VERSION = ColVis.VERSION;





/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Initialisation
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/*
 * Register a new feature with DataTables
 */
if ( typeof $.fn.dataTable == "function" &&
     typeof $.fn.dataTableExt.fnVersionCheck == "function" &&
     $.fn.dataTableExt.fnVersionCheck('1.7.0') )
{
	$.fn.dataTableExt.aoFeatures.push( {
		"fnInit": function( oDTSettings ) {
			var init = oDTSettings.oInit;
			var colvis = new ColVis( oDTSettings, init.colVis || init.oColVis || {} );
			return colvis.button();
		},
		"cFeature": "C",
		"sFeature": "ColVis"
	} );
}
else
{
	alert( "Warning: ColVis requires DataTables 1.7 or greater - www.datatables.net/download");
}


// Make ColVis accessible from the DataTables instance
$.fn.dataTable.ColVis = ColVis;
$.fn.DataTable.ColVis = ColVis;


return ColVis;
}; // /factory


// Define as an AMD module if possible
if ( typeof define === 'function' && define.amd ) {
	define( ['jquery', 'datatables'], factory );
}
else if ( typeof exports === 'object' ) {
    // Node/CommonJS
    factory( require('jquery'), require('datatables') );
}
else if ( jQuery && !jQuery.fn.dataTable.ColVis ) {
	// Otherwise simply initialise as normal, stopping multiple evaluation
	factory( jQuery, jQuery.fn.dataTable );
}


})(window, document);

///bibmas using datatables extension/plugin 

/*! ColReorder 1.1.3
 * ©2010-2014 SpryMedia Ltd - datatables.net/license
 */

/**
 * @summary     ColReorder
 * @description Provide the ability to reorder columns in a DataTable
 * @version     1.1.3
 * @file        dataTables.colReorder.js
 * @author      SpryMedia Ltd (www.sprymedia.co.uk)
 * @contact     www.sprymedia.co.uk/contact
 * @copyright   Copyright 2010-2014 SpryMedia Ltd.
 *
 * This source file is free software, available under the following license:
 *   MIT license - http://datatables.net/license/mit
 *
 * This source file is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the license files for details.
 *
 * For details please refer to: http://www.datatables.net
 */

(function(window, document, undefined) {


/**
 * Switch the key value pairing of an index array to be value key (i.e. the old value is now the
 * key). For example consider [ 2, 0, 1 ] this would be returned as [ 1, 2, 0 ].
 *  @method  fnInvertKeyValues
 *  @param   array aIn Array to switch around
 *  @returns array
 */
function fnInvertKeyValues( aIn )
{
	var aRet=[];
	for ( var i=0, iLen=aIn.length ; i<iLen ; i++ )
	{
		aRet[ aIn[i] ] = i;
	}
	return aRet;
}


/**
 * Modify an array by switching the position of two elements
 *  @method  fnArraySwitch
 *  @param   array aArray Array to consider, will be modified by reference (i.e. no return)
 *  @param   int iFrom From point
 *  @param   int iTo Insert point
 *  @returns void
 */
function fnArraySwitch( aArray, iFrom, iTo )
{
	var mStore = aArray.splice( iFrom, 1 )[0];
	aArray.splice( iTo, 0, mStore );
}


/**
 * Switch the positions of nodes in a parent node (note this is specifically designed for
 * table rows). Note this function considers all element nodes under the parent!
 *  @method  fnDomSwitch
 *  @param   string sTag Tag to consider
 *  @param   int iFrom Element to move
 *  @param   int Point to element the element to (before this point), can be null for append
 *  @returns void
 */
function fnDomSwitch( nParent, iFrom, iTo )
{
	var anTags = [];
	for ( var i=0, iLen=nParent.childNodes.length ; i<iLen ; i++ )
	{
		if ( nParent.childNodes[i].nodeType == 1 )
		{
			anTags.push( nParent.childNodes[i] );
		}
	}
	var nStore = anTags[ iFrom ];

	if ( iTo !== null )
	{
		nParent.insertBefore( nStore, anTags[iTo] );
	}
	else
	{
		nParent.appendChild( nStore );
	}
}



var factory = function( $, DataTable ) {
"use strict";

/**
 * Plug-in for DataTables which will reorder the internal column structure by taking the column
 * from one position (iFrom) and insert it into a given point (iTo).
 *  @method  $.fn.dataTableExt.oApi.fnColReorder
 *  @param   object oSettings DataTables settings object - automatically added by DataTables!
 *  @param   int iFrom Take the column to be repositioned from this point
 *  @param   int iTo and insert it into this point
 *  @returns void
 */
$.fn.dataTableExt.oApi.fnColReorder = function ( oSettings, iFrom, iTo )
{
	var v110 = $.fn.dataTable.Api ? true : false;
	var i, iLen, j, jLen, iCols=oSettings.aoColumns.length, nTrs, oCol;
	var attrMap = function ( obj, prop, mapping ) {
		if ( ! obj[ prop ] ) {
			return;
		}

		var a = obj[ prop ].split('.');
		var num = a.shift();

		if ( isNaN( num*1 ) ) {
			return;
		}

		obj[ prop ] = mapping[ num*1 ]+'.'+a.join('.');
	};

	/* Sanity check in the input */
	if ( iFrom == iTo )
	{
		/* Pointless reorder */
		return;
	}

	if ( iFrom < 0 || iFrom >= iCols )
	{
		this.oApi._fnLog( oSettings, 1, "ColReorder 'from' index is out of bounds: "+iFrom );
		return;
	}

	if ( iTo < 0 || iTo >= iCols )
	{
		this.oApi._fnLog( oSettings, 1, "ColReorder 'to' index is out of bounds: "+iTo );
		return;
	}

	/*
	 * Calculate the new column array index, so we have a mapping between the old and new
	 */
	var aiMapping = [];
	for ( i=0, iLen=iCols ; i<iLen ; i++ )
	{
		aiMapping[i] = i;
	}
	fnArraySwitch( aiMapping, iFrom, iTo );
	var aiInvertMapping = fnInvertKeyValues( aiMapping );


	/*
	 * Convert all internal indexing to the new column order indexes
	 */
	/* Sorting */
	for ( i=0, iLen=oSettings.aaSorting.length ; i<iLen ; i++ )
	{
		oSettings.aaSorting[i][0] = aiInvertMapping[ oSettings.aaSorting[i][0] ];
	}

	/* Fixed sorting */
	if ( oSettings.aaSortingFixed !== null )
	{
		for ( i=0, iLen=oSettings.aaSortingFixed.length ; i<iLen ; i++ )
		{
			oSettings.aaSortingFixed[i][0] = aiInvertMapping[ oSettings.aaSortingFixed[i][0] ];
		}
	}

	/* Data column sorting (the column which the sort for a given column should take place on) */
	for ( i=0, iLen=iCols ; i<iLen ; i++ )
	{
		oCol = oSettings.aoColumns[i];
		for ( j=0, jLen=oCol.aDataSort.length ; j<jLen ; j++ )
		{
			oCol.aDataSort[j] = aiInvertMapping[ oCol.aDataSort[j] ];
		}

		// Update the column indexes
		if ( v110 ) {
			oCol.idx = aiInvertMapping[ oCol.idx ];
		}
	}

	if ( v110 ) {
		// Update 1.10 optimised sort class removal variable
		$.each( oSettings.aLastSort, function (i, val) {
			oSettings.aLastSort[i].src = aiInvertMapping[ val.src ];
		} );
	}

	/* Update the Get and Set functions for each column */
	for ( i=0, iLen=iCols ; i<iLen ; i++ )
	{
		oCol = oSettings.aoColumns[i];

		if ( typeof oCol.mData == 'number' ) {
			oCol.mData = aiInvertMapping[ oCol.mData ];

			// regenerate the get / set functions
			oSettings.oApi._fnColumnOptions( oSettings, i, {} );
		}
		else if ( $.isPlainObject( oCol.mData ) ) {
			// HTML5 data sourced
			attrMap( oCol.mData, '_',      aiInvertMapping );
			attrMap( oCol.mData, 'filter', aiInvertMapping );
			attrMap( oCol.mData, 'sort',   aiInvertMapping );
			attrMap( oCol.mData, 'type',   aiInvertMapping );

			// regenerate the get / set functions
			oSettings.oApi._fnColumnOptions( oSettings, i, {} );
		}
	}


	/*
	 * Move the DOM elements
	 */
	if ( oSettings.aoColumns[iFrom].bVisible )
	{
		/* Calculate the current visible index and the point to insert the node before. The insert
		 * before needs to take into account that there might not be an element to insert before,
		 * in which case it will be null, and an appendChild should be used
		 */
		var iVisibleIndex = this.oApi._fnColumnIndexToVisible( oSettings, iFrom );
		var iInsertBeforeIndex = null;

		i = iTo < iFrom ? iTo : iTo + 1;
		while ( iInsertBeforeIndex === null && i < iCols )
		{
			iInsertBeforeIndex = this.oApi._fnColumnIndexToVisible( oSettings, i );
			i++;
		}

		/* Header */
		nTrs = oSettings.nTHead.getElementsByTagName('tr');
		for ( i=0, iLen=nTrs.length ; i<iLen ; i++ )
		{
			fnDomSwitch( nTrs[i], iVisibleIndex, iInsertBeforeIndex );
		}

		/* Footer */
		if ( oSettings.nTFoot !== null )
		{
			nTrs = oSettings.nTFoot.getElementsByTagName('tr');
			for ( i=0, iLen=nTrs.length ; i<iLen ; i++ )
			{
				fnDomSwitch( nTrs[i], iVisibleIndex, iInsertBeforeIndex );
			}
		}

		/* Body */
		for ( i=0, iLen=oSettings.aoData.length ; i<iLen ; i++ )
		{
			if ( oSettings.aoData[i].nTr !== null )
			{
				fnDomSwitch( oSettings.aoData[i].nTr, iVisibleIndex, iInsertBeforeIndex );
			}
		}
	}

	/*
	 * Move the internal array elements
	 */
	/* Columns */
	fnArraySwitch( oSettings.aoColumns, iFrom, iTo );

	/* Search columns */
	fnArraySwitch( oSettings.aoPreSearchCols, iFrom, iTo );

	/* Array array - internal data anodes cache */
	for ( i=0, iLen=oSettings.aoData.length ; i<iLen ; i++ )
	{
		var data = oSettings.aoData[i];

		if ( v110 ) {
			// DataTables 1.10+
			if ( data.anCells ) {
				fnArraySwitch( data.anCells, iFrom, iTo );
			}

			// For DOM sourced data, the invalidate will reread the cell into
			// the data array, but for data sources as an array, they need to
			// be flipped
			if ( data.src !== 'dom' && $.isArray( data._aData ) ) {
				fnArraySwitch( data._aData, iFrom, iTo );
			}
		}
		else {
			// DataTables 1.9-
			if ( $.isArray( data._aData ) ) {
				fnArraySwitch( data._aData, iFrom, iTo );
			}
			fnArraySwitch( data._anHidden, iFrom, iTo );
		}
	}

	/* Reposition the header elements in the header layout array */
	for ( i=0, iLen=oSettings.aoHeader.length ; i<iLen ; i++ )
	{
		fnArraySwitch( oSettings.aoHeader[i], iFrom, iTo );
	}

	if ( oSettings.aoFooter !== null )
	{
		for ( i=0, iLen=oSettings.aoFooter.length ; i<iLen ; i++ )
		{
			fnArraySwitch( oSettings.aoFooter[i], iFrom, iTo );
		}
	}

	// In 1.10 we need to invalidate row cached data for sorting, filtering etc
	if ( v110 ) {
		var api = new $.fn.dataTable.Api( oSettings );
		api.rows().invalidate();
	}

	/*
	 * Update DataTables' event handlers
	 */

	/* Sort listener */
	for ( i=0, iLen=iCols ; i<iLen ; i++ )
	{
		$(oSettings.aoColumns[i].nTh).off('click.DT');
		this.oApi._fnSortAttachListener( oSettings, oSettings.aoColumns[i].nTh, i );
	}


	/* Fire an event so other plug-ins can update */
	$(oSettings.oInstance).trigger( 'column-reorder', [ oSettings, {
		"iFrom": iFrom,
		"iTo": iTo,
		"aiInvertMapping": aiInvertMapping
	} ] );
};


/**
 * ColReorder provides column visibility control for DataTables
 * @class ColReorder
 * @constructor
 * @param {object} dt DataTables settings object
 * @param {object} opts ColReorder options
 */
var ColReorder = function( dt, opts )
{
	var oDTSettings;

	if ( $.fn.dataTable.Api ) {
		oDTSettings = new $.fn.dataTable.Api( dt ).settings()[0];
	}
	// 1.9 compatibility
	else if ( dt.fnSettings ) {
		// DataTables object, convert to the settings object
		oDTSettings = dt.fnSettings();
	}
	else if ( typeof dt === 'string' ) {
		// jQuery selector
		if ( $.fn.dataTable.fnIsDataTable( $(dt)[0] ) ) {
			oDTSettings = $(dt).eq(0).dataTable().fnSettings();
		}
	}
	else if ( dt.nodeName && dt.nodeName.toLowerCase() === 'table' ) {
		// Table node
		if ( $.fn.dataTable.fnIsDataTable( dt.nodeName ) ) {
			oDTSettings = $(dt.nodeName).dataTable().fnSettings();
		}
	}
	else if ( dt instanceof jQuery ) {
		// jQuery object
		if ( $.fn.dataTable.fnIsDataTable( dt[0] ) ) {
			oDTSettings = dt.eq(0).dataTable().fnSettings();
		}
	}
	else {
		// DataTables settings object
		oDTSettings = dt;
	}

	// Ensure that we can't initialise on the same table twice
	if ( oDTSettings._colReorder ) {
		throw "ColReorder already initialised on table #"+oDTSettings.nTable.id;
	}

	// Convert from camelCase to Hungarian, just as DataTables does
	var camelToHungarian = $.fn.dataTable.camelToHungarian;
	if ( camelToHungarian ) {
		camelToHungarian( ColReorder.defaults, ColReorder.defaults, true );
		camelToHungarian( ColReorder.defaults, opts || {} );
	}


	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 * Public class variables
	 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

	/**
	 * @namespace Settings object which contains customisable information for ColReorder instance
	 */
	this.s = {
		/**
		 * DataTables settings object
		 *  @property dt
		 *  @type     Object
		 *  @default  null
		 */
		"dt": null,

		/**
		 * Initialisation object used for this instance
		 *  @property init
		 *  @type     object
		 *  @default  {}
		 */
		"init": $.extend( true, {}, ColReorder.defaults, opts ),

		/**
		 * Number of columns to fix (not allow to be reordered)
		 *  @property fixed
		 *  @type     int
		 *  @default  0
		 */
		"fixed": 0,

		/**
		 * Number of columns to fix counting from right (not allow to be reordered)
		 *  @property fixedRight
		 *  @type     int
		 *  @default  0
		 */
		"fixedRight": 0,

		/**
		 * Callback function for once the reorder has been done
		 *  @property reorderCallback
		 *  @type     function
		 *  @default  null
		 */
		"reorderCallback": null,

		/**
		 * @namespace Information used for the mouse drag
		 */
		"mouse": {
			"startX": -1,
			"startY": -1,
			"offsetX": -1,
			"offsetY": -1,
			"target": -1,
			"targetIndex": -1,
			"fromIndex": -1
		},

		/**
		 * Information which is used for positioning the insert cusor and knowing where to do the
		 * insert. Array of objects with the properties:
		 *   x: x-axis position
		 *   to: insert point
		 *  @property aoTargets
		 *  @type     array
		 *  @default  []
		 */
		"aoTargets": []
	};


	/**
	 * @namespace Common and useful DOM elements for the class instance
	 */
	this.dom = {
		/**
		 * Dragging element (the one the mouse is moving)
		 *  @property drag
		 *  @type     element
		 *  @default  null
		 */
		"drag": null,

		/**
		 * The insert cursor
		 *  @property pointer
		 *  @type     element
		 *  @default  null
		 */
		"pointer": null
	};


	/* Constructor logic */
	this.s.dt = oDTSettings;
	this.s.dt._colReorder = this;
	this._fnConstruct();

	/* Add destroy callback */
	oDTSettings.oApi._fnCallbackReg(oDTSettings, 'aoDestroyCallback', $.proxy(this._fnDestroy, this), 'ColReorder');

	return this;
};



ColReorder.prototype = {
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 * Public methods
	 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

	/**
	 * Reset the column ordering to the original ordering that was detected on
	 * start up.
	 *  @return {this} Returns `this` for chaining.
	 *
	 *  @example
	 *    // DataTables initialisation with ColReorder
	 *    var table = $('#example').dataTable( {
	 *        "sDom": 'Rlfrtip'
	 *    } );
	 *
	 *    // Add click event to a button to reset the ordering
	 *    $('#resetOrdering').click( function (e) {
	 *        e.preventDefault();
	 *        $.fn.dataTable.ColReorder( table ).fnReset();
	 *    } );
	 */
	"fnReset": function ()
	{
		var a = [];
		for ( var i=0, iLen=this.s.dt.aoColumns.length ; i<iLen ; i++ )
		{
			a.push( this.s.dt.aoColumns[i]._ColReorder_iOrigCol );
		}

		this._fnOrderColumns( a );

		return this;
	},

	/**
	 * `Deprecated` - Get the current order of the columns, as an array.
	 *  @return {array} Array of column identifiers
	 *  @deprecated `fnOrder` should be used in preference to this method.
	 *      `fnOrder` acts as a getter/setter.
	 */
	"fnGetCurrentOrder": function ()
	{
		return this.fnOrder();
	},

	/**
	 * Get the current order of the columns, as an array. Note that the values
	 * given in the array are unique identifiers for each column. Currently
	 * these are the original ordering of the columns that was detected on
	 * start up, but this could potentially change in future.
	 *  @return {array} Array of column identifiers
	 *
	 *  @example
	 *    // Get column ordering for the table
	 *    var order = $.fn.dataTable.ColReorder( dataTable ).fnOrder();
	 *//**
	 * Set the order of the columns, from the positions identified in the
	 * ordering array given. Note that ColReorder takes a brute force approach
	 * to reordering, so it is possible multiple reordering events will occur
	 * before the final order is settled upon.
	 *  @param {array} [set] Array of column identifiers in the new order. Note
	 *    that every column must be included, uniquely, in this array.
	 *  @return {this} Returns `this` for chaining.
	 *
	 *  @example
	 *    // Swap the first and second columns
	 *    $.fn.dataTable.ColReorder( dataTable ).fnOrder( [1, 0, 2, 3, 4] );
	 *
	 *  @example
	 *    // Move the first column to the end for the table `#example`
	 *    var curr = $.fn.dataTable.ColReorder( '#example' ).fnOrder();
	 *    var first = curr.shift();
	 *    curr.push( first );
	 *    $.fn.dataTable.ColReorder( '#example' ).fnOrder( curr );
	 *
	 *  @example
	 *    // Reverse the table's order
	 *    $.fn.dataTable.ColReorder( '#example' ).fnOrder(
	 *      $.fn.dataTable.ColReorder( '#example' ).fnOrder().reverse()
	 *    );
	 */
	"fnOrder": function ( set )
	{
		if ( set === undefined )
		{
			var a = [];
			for ( var i=0, iLen=this.s.dt.aoColumns.length ; i<iLen ; i++ )
			{
				a.push( this.s.dt.aoColumns[i]._ColReorder_iOrigCol );
			}
			return a;
		}

		this._fnOrderColumns( fnInvertKeyValues( set ) );

		return this;
	},


	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 * Private methods (they are of course public in JS, but recommended as private)
	 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

	/**
	 * Constructor logic
	 *  @method  _fnConstruct
	 *  @returns void
	 *  @private
	 */
	"_fnConstruct": function ()
	{
		var that = this;
		var iLen = this.s.dt.aoColumns.length;
		var i;

		/* Columns discounted from reordering - counting left to right */
		if ( this.s.init.iFixedColumns )
		{
			this.s.fixed = this.s.init.iFixedColumns;
		}

		/* Columns discounted from reordering - counting right to left */
		this.s.fixedRight = this.s.init.iFixedColumnsRight ?
			this.s.init.iFixedColumnsRight :
			0;

		/* Drop callback initialisation option */
		if ( this.s.init.fnReorderCallback )
		{
			this.s.reorderCallback = this.s.init.fnReorderCallback;
		}

		/* Add event handlers for the drag and drop, and also mark the original column order */
		for ( i = 0; i < iLen; i++ )
		{
			if ( i > this.s.fixed-1 && i < iLen - this.s.fixedRight )
			{
				this._fnMouseListener( i, this.s.dt.aoColumns[i].nTh );
			}

			/* Mark the original column order for later reference */
			this.s.dt.aoColumns[i]._ColReorder_iOrigCol = i;
		}

		/* State saving */
		this.s.dt.oApi._fnCallbackReg( this.s.dt, 'aoStateSaveParams', function (oS, oData) {
			that._fnStateSave.call( that, oData );
		}, "ColReorder_State" );

		/* An initial column order has been specified */
		var aiOrder = null;
		if ( this.s.init.aiOrder )
		{
			aiOrder = this.s.init.aiOrder.slice();
		}

		/* State loading, overrides the column order given */
		if ( this.s.dt.oLoadedState && typeof this.s.dt.oLoadedState.ColReorder != 'undefined' &&
		  this.s.dt.oLoadedState.ColReorder.length == this.s.dt.aoColumns.length )
		{
			aiOrder = this.s.dt.oLoadedState.ColReorder;
		}

		/* If we have an order to apply - do so */
		if ( aiOrder )
		{
			/* We might be called during or after the DataTables initialisation. If before, then we need
			 * to wait until the draw is done, if after, then do what we need to do right away
			 */
			if ( !that.s.dt._bInitComplete )
			{
				var bDone = false;
				this.s.dt.aoDrawCallback.push( {
					"fn": function () {
						if ( !that.s.dt._bInitComplete && !bDone )
						{
							bDone = true;
							var resort = fnInvertKeyValues( aiOrder );
							that._fnOrderColumns.call( that, resort );
						}
					},
					"sName": "ColReorder_Pre"
				} );
			}
			else
			{
				var resort = fnInvertKeyValues( aiOrder );
				that._fnOrderColumns.call( that, resort );
			}
		}
		else {
			this._fnSetColumnIndexes();
		}
	},


	/**
	 * Set the column order from an array
	 *  @method  _fnOrderColumns
	 *  @param   array a An array of integers which dictate the column order that should be applied
	 *  @returns void
	 *  @private
	 */
	"_fnOrderColumns": function ( a )
	{
		if ( a.length != this.s.dt.aoColumns.length )
		{
			this.s.dt.oInstance.oApi._fnLog( this.s.dt, 1, "ColReorder - array reorder does not "+
				"match known number of columns. Skipping." );
			return;
		}

		for ( var i=0, iLen=a.length ; i<iLen ; i++ )
		{
			var currIndex = $.inArray( i, a );
			if ( i != currIndex )
			{
				/* Reorder our switching array */
				fnArraySwitch( a, currIndex, i );

				/* Do the column reorder in the table */
				this.s.dt.oInstance.fnColReorder( currIndex, i );
			}
		}

		/* When scrolling we need to recalculate the column sizes to allow for the shift */
		if ( this.s.dt.oScroll.sX !== "" || this.s.dt.oScroll.sY !== "" )
		{
			this.s.dt.oInstance.fnAdjustColumnSizing( false );
		}

		/* Save the state */
		this.s.dt.oInstance.oApi._fnSaveState( this.s.dt );

		this._fnSetColumnIndexes();
		
		if ( this.s.reorderCallback !== null )
		{
			this.s.reorderCallback.call( this );
		}
	},


	/**
	 * Because we change the indexes of columns in the table, relative to their starting point
	 * we need to reorder the state columns to what they are at the starting point so we can
	 * then rearrange them again on state load!
	 *  @method  _fnStateSave
	 *  @param   object oState DataTables state
	 *  @returns string JSON encoded cookie string for DataTables
	 *  @private
	 */
	"_fnStateSave": function ( oState )
	{
		var i, iLen, aCopy, iOrigColumn;
		var oSettings = this.s.dt;
		var columns = oSettings.aoColumns;

		oState.ColReorder = [];

		/* Sorting */
		if ( oState.aaSorting ) {
			// 1.10.0-
			for ( i=0 ; i<oState.aaSorting.length ; i++ ) {
				oState.aaSorting[i][0] = columns[ oState.aaSorting[i][0] ]._ColReorder_iOrigCol;
			}

			var aSearchCopy = $.extend( true, [], oState.aoSearchCols );

			for ( i=0, iLen=columns.length ; i<iLen ; i++ )
			{
				iOrigColumn = columns[i]._ColReorder_iOrigCol;

				/* Column filter */
				oState.aoSearchCols[ iOrigColumn ] = aSearchCopy[i];

				/* Visibility */
				oState.abVisCols[ iOrigColumn ] = columns[i].bVisible;

				/* Column reordering */
				oState.ColReorder.push( iOrigColumn );
			}
		}
		else if ( oState.order ) {
			// 1.10.1+
			for ( i=0 ; i<oState.order.length ; i++ ) {
				oState.order[i][0] = columns[ oState.order[i][0] ]._ColReorder_iOrigCol;
			}

			var stateColumnsCopy = $.extend( true, [], oState.columns );

			for ( i=0, iLen=columns.length ; i<iLen ; i++ )
			{
				iOrigColumn = columns[i]._ColReorder_iOrigCol;

				/* Columns */
				oState.columns[ iOrigColumn ] = stateColumnsCopy[i];

				/* Column reordering */
				oState.ColReorder.push( iOrigColumn );
			}
		}
	},


	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 * Mouse drop and drag
	 */

	/**
	 * Add a mouse down listener to a particluar TH element
	 *  @method  _fnMouseListener
	 *  @param   int i Column index
	 *  @param   element nTh TH element clicked on
	 *  @returns void
	 *  @private
	 */
	"_fnMouseListener": function ( i, nTh )
	{
		var that = this;
		$(nTh).on( 'mousedown.ColReorder', function (e) {
			e.preventDefault();
			that._fnMouseDown.call( that, e, nTh );
		} );
	},


	/**
	 * Mouse down on a TH element in the table header
	 *  @method  _fnMouseDown
	 *  @param   event e Mouse event
	 *  @param   element nTh TH element to be dragged
	 *  @returns void
	 *  @private
	 */
	"_fnMouseDown": function ( e, nTh )
	{
		var that = this;

		/* Store information about the mouse position */
		var target = $(e.target).closest('th, td');
		var offset = target.offset();
		var idx = parseInt( $(nTh).attr('data-column-index'), 10 );

		if ( idx === undefined ) {
			return;
		}

		this.s.mouse.startX = e.pageX;
		this.s.mouse.startY = e.pageY;
		this.s.mouse.offsetX = e.pageX - offset.left;
		this.s.mouse.offsetY = e.pageY - offset.top;
		this.s.mouse.target = this.s.dt.aoColumns[ idx ].nTh;//target[0];
		this.s.mouse.targetIndex = idx;
		this.s.mouse.fromIndex = idx;

		this._fnRegions();

		/* Add event handlers to the document */
		$(document)
			.on( 'mousemove.ColReorder', function (e) {
				that._fnMouseMove.call( that, e );
			} )
			.on( 'mouseup.ColReorder', function (e) {
				that._fnMouseUp.call( that, e );
			} );
	},


	/**
	 * Deal with a mouse move event while dragging a node
	 *  @method  _fnMouseMove
	 *  @param   event e Mouse event
	 *  @returns void
	 *  @private
	 */
	"_fnMouseMove": function ( e )
	{
		var that = this;

		if ( this.dom.drag === null )
		{
			/* Only create the drag element if the mouse has moved a specific distance from the start
			 * point - this allows the user to make small mouse movements when sorting and not have a
			 * possibly confusing drag element showing up
			 */
			if ( Math.pow(
				Math.pow(e.pageX - this.s.mouse.startX, 2) +
				Math.pow(e.pageY - this.s.mouse.startY, 2), 0.5 ) < 5 )
			{
				return;
			}
			this._fnCreateDragNode();
		}

		/* Position the element - we respect where in the element the click occured */
		this.dom.drag.css( {
			left: e.pageX - this.s.mouse.offsetX,
			top: e.pageY - this.s.mouse.offsetY
		} );

		/* Based on the current mouse position, calculate where the insert should go */
		var bSet = false;
		var lastToIndex = this.s.mouse.toIndex;

		for ( var i=1, iLen=this.s.aoTargets.length ; i<iLen ; i++ )
		{
			if ( e.pageX < this.s.aoTargets[i-1].x + ((this.s.aoTargets[i].x-this.s.aoTargets[i-1].x)/2) )
			{
				this.dom.pointer.css( 'left', this.s.aoTargets[i-1].x );
				this.s.mouse.toIndex = this.s.aoTargets[i-1].to;
				bSet = true;
				break;
			}
		}

		// The insert element wasn't positioned in the array (less than
		// operator), so we put it at the end
		if ( !bSet )
		{
			this.dom.pointer.css( 'left', this.s.aoTargets[this.s.aoTargets.length-1].x );
			this.s.mouse.toIndex = this.s.aoTargets[this.s.aoTargets.length-1].to;
		}

		// Perform reordering if realtime updating is on and the column has moved
		if ( this.s.init.bRealtime && lastToIndex !== this.s.mouse.toIndex ) {
			this.s.dt.oInstance.fnColReorder( this.s.mouse.fromIndex, this.s.mouse.toIndex );
			this.s.mouse.fromIndex = this.s.mouse.toIndex;
			this._fnRegions();
		}
	},


	/**
	 * Finish off the mouse drag and insert the column where needed
	 *  @method  _fnMouseUp
	 *  @param   event e Mouse event
	 *  @returns void
	 *  @private
	 */
	"_fnMouseUp": function ( e )
	{
		var that = this;

		$(document).off( 'mousemove.ColReorder mouseup.ColReorder' );

		if ( this.dom.drag !== null )
		{
			/* Remove the guide elements */
			this.dom.drag.remove();
			this.dom.pointer.remove();
			this.dom.drag = null;
			this.dom.pointer = null;

			/* Actually do the reorder */
			this.s.dt.oInstance.fnColReorder( this.s.mouse.fromIndex, this.s.mouse.toIndex );
			this._fnSetColumnIndexes();

			/* When scrolling we need to recalculate the column sizes to allow for the shift */
			if ( this.s.dt.oScroll.sX !== "" || this.s.dt.oScroll.sY !== "" )
			{
				this.s.dt.oInstance.fnAdjustColumnSizing( false );
			}

			/* Save the state */
			this.s.dt.oInstance.oApi._fnSaveState( this.s.dt );

			if ( this.s.reorderCallback !== null )
			{
				this.s.reorderCallback.call( this );
			}
		}
	},


	/**
	 * Calculate a cached array with the points of the column inserts, and the
	 * 'to' points
	 *  @method  _fnRegions
	 *  @returns void
	 *  @private
	 */
	"_fnRegions": function ()
	{
		var aoColumns = this.s.dt.aoColumns;

		this.s.aoTargets.splice( 0, this.s.aoTargets.length );

		this.s.aoTargets.push( {
			"x":  $(this.s.dt.nTable).offset().left,
			"to": 0
		} );

		var iToPoint = 0;
		for ( var i=0, iLen=aoColumns.length ; i<iLen ; i++ )
		{
			/* For the column / header in question, we want it's position to remain the same if the
			 * position is just to it's immediate left or right, so we only incremement the counter for
			 * other columns
			 */
			if ( i != this.s.mouse.fromIndex )
			{
				iToPoint++;
			}

			if ( aoColumns[i].bVisible )
			{
				this.s.aoTargets.push( {
					"x":  $(aoColumns[i].nTh).offset().left + $(aoColumns[i].nTh).outerWidth(),
					"to": iToPoint
				} );
			}
		}

		/* Disallow columns for being reordered by drag and drop, counting right to left */
		if ( this.s.fixedRight !== 0 )
		{
			this.s.aoTargets.splice( this.s.aoTargets.length - this.s.fixedRight );
		}

		/* Disallow columns for being reordered by drag and drop, counting left to right */
		if ( this.s.fixed !== 0 )
		{
			this.s.aoTargets.splice( 0, this.s.fixed );
		}
	},


	/**
	 * Copy the TH element that is being drags so the user has the idea that they are actually
	 * moving it around the page.
	 *  @method  _fnCreateDragNode
	 *  @returns void
	 *  @private
	 */
	"_fnCreateDragNode": function ()
	{
		var scrolling = this.s.dt.oScroll.sX !== "" || this.s.dt.oScroll.sY !== "";

		var origCell = this.s.dt.aoColumns[ this.s.mouse.targetIndex ].nTh;
		var origTr = origCell.parentNode;
		var origThead = origTr.parentNode;
		var origTable = origThead.parentNode;
		var cloneCell = $(origCell).clone();

		// This is a slightly odd combination of jQuery and DOM, but it is the
		// fastest and least resource intensive way I could think of cloning
		// the table with just a single header cell in it.
		this.dom.drag = $(origTable.cloneNode(false))
			.addClass( 'DTCR_clonedTable' )
			.append(
				$(origThead.cloneNode(false)).append(
					$(origTr.cloneNode(false)).append(
						cloneCell[0]
					)
				)
			)
			.css( {
				position: 'absolute',
				top: 0,
				left: 0,
				width: $(origCell).outerWidth(),
				height: $(origCell).outerHeight()
			} )
			.appendTo( 'body' );

		this.dom.pointer = $('<div></div>')
			.addClass( 'DTCR_pointer' )
			.css( {
				position: 'absolute',
				top: scrolling ?
					$('div.dataTables_scroll', this.s.dt.nTableWrapper).offset().top :
					$(this.s.dt.nTable).offset().top,
				height : scrolling ?
					$('div.dataTables_scroll', this.s.dt.nTableWrapper).height() :
					$(this.s.dt.nTable).height()
			} )
			.appendTo( 'body' );
	},

	/**
	 * Clean up ColReorder memory references and event handlers
	 *  @method  _fnDestroy
	 *  @returns void
	 *  @private
	 */
	"_fnDestroy": function ()
	{
		var i, iLen;

		for ( i=0, iLen=this.s.dt.aoDrawCallback.length ; i<iLen ; i++ )
		{
			if ( this.s.dt.aoDrawCallback[i].sName === 'ColReorder_Pre' )
			{
				this.s.dt.aoDrawCallback.splice( i, 1 );
				break;
			}
		}

		$(this.s.dt.nTHead).find( '*' ).off( '.ColReorder' );

		$.each( this.s.dt.aoColumns, function (i, column) {
			$(column.nTh).removeAttr('data-column-index');
		} );

		this.s.dt._colReorder = null;
		this.s = null;
	},


	/**
	 * Add a data attribute to the column headers, so we know the index of
	 * the row to be reordered. This allows fast detection of the index, and
	 * for this plug-in to work with FixedHeader which clones the nodes.
	 *  @private
	 */
	"_fnSetColumnIndexes": function ()
	{
		$.each( this.s.dt.aoColumns, function (i, column) {
			$(column.nTh).attr('data-column-index', i);
		} );
	}
};





/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Static parameters
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


/**
 * ColReorder default settings for initialisation
 *  @namespace
 *  @static
 */
ColReorder.defaults = {
	/**
	 * Predefined ordering for the columns that will be applied automatically
	 * on initialisation. If not specified then the order that the columns are
	 * found to be in the HTML is the order used.
	 *  @type array
	 *  @default null
	 *  @static
	 *  @example
	 *      // Using the `oColReorder` option in the DataTables options object
	 *      $('#example').dataTable( {
	 *          "sDom": 'Rlfrtip',
	 *          "oColReorder": {
	 *              "aiOrder": [ 4, 3, 2, 1, 0 ]
	 *          }
	 *      } );
	 *
	 *  @example
	 *      // Using `new` constructor
	 *      $('#example').dataTable()
	 *
	 *      new $.fn.dataTable.ColReorder( '#example', {
	 *          "aiOrder": [ 4, 3, 2, 1, 0 ]
	 *      } );
	 */
	aiOrder: null,

	/**
	 * Redraw the table's column ordering as the end user draws the column
	 * (`true`) or wait until the mouse is released (`false` - default). Note
	 * that this will perform a redraw on each reordering, which involves an
	 * Ajax request each time if you are using server-side processing in
	 * DataTables.
	 *  @type boolean
	 *  @default false
	 *  @static
	 *  @example
	 *      // Using the `oColReorder` option in the DataTables options object
	 *      $('#example').dataTable( {
	 *          "sDom": 'Rlfrtip',
	 *          "oColReorder": {
	 *              "bRealtime": true
	 *          }
	 *      } );
	 *
	 *  @example
	 *      // Using `new` constructor
	 *      $('#example').dataTable()
	 *
	 *      new $.fn.dataTable.ColReorder( '#example', {
	 *          "bRealtime": true
	 *      } );
	 */
	bRealtime: false,

	/**
	 * Indicate how many columns should be fixed in position (counting from the
	 * left). This will typically be 1 if used, but can be as high as you like.
	 *  @type int
	 *  @default 0
	 *  @static
	 *  @example
	 *      // Using the `oColReorder` option in the DataTables options object
	 *      $('#example').dataTable( {
	 *          "sDom": 'Rlfrtip',
	 *          "oColReorder": {
	 *              "iFixedColumns": 1
	 *          }
	 *      } );
	 *
	 *  @example
	 *      // Using `new` constructor
	 *      $('#example').dataTable()
	 *
	 *      new $.fn.dataTable.ColReorder( '#example', {
	 *          "iFixedColumns": 1
	 *      } );
	 */
	iFixedColumns: 0,

	/**
	 * As `iFixedColumnsRight` but counting from the right.
	 *  @type int
	 *  @default 0
	 *  @static
	 *  @example
	 *      // Using the `oColReorder` option in the DataTables options object
	 *      $('#example').dataTable( {
	 *          "sDom": 'Rlfrtip',
	 *          "oColReorder": {
	 *              "iFixedColumnsRight": 1
	 *          }
	 *      } );
	 *
	 *  @example
	 *      // Using `new` constructor
	 *      $('#example').dataTable()
	 *
	 *      new $.fn.dataTable.ColReorder( '#example', {
	 *          "iFixedColumnsRight": 1
	 *      } );
	 */
	iFixedColumnsRight: 0,

	/**
	 * Callback function that is fired when columns are reordered
	 *  @type function():void
	 *  @default null
	 *  @static
	 *  @example
	 *      // Using the `oColReorder` option in the DataTables options object
	 *      $('#example').dataTable( {
	 *          "sDom": 'Rlfrtip',
	 *          "oColReorder": {
	 *              "fnReorderCallback": function () {
	 *                  alert( 'Columns reordered' );
	 *              }
	 *          }
	 *      } );
	 *
	 *  @example
	 *      // Using `new` constructor
	 *      $('#example').dataTable()
	 *
	 *      new $.fn.dataTable.ColReorder( '#example', {
	 *          "fnReorderCallback": function () {
	 *              alert( 'Columns reordered' );
	 *          }
	 *      } );
	 */
	fnReorderCallback: null
};



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Constants
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/**
 * ColReorder version
 *  @constant  version
 *  @type      String
 *  @default   As code
 */
ColReorder.version = "1.1.3";



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * DataTables interfaces
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// Expose
$.fn.dataTable.ColReorder = ColReorder;
$.fn.DataTable.ColReorder = ColReorder;


// Register a new feature with DataTables
if ( typeof $.fn.dataTable == "function" &&
     typeof $.fn.dataTableExt.fnVersionCheck == "function" &&
     $.fn.dataTableExt.fnVersionCheck('1.9.3') )
{
	$.fn.dataTableExt.aoFeatures.push( {
		"fnInit": function( settings ) {
			var table = settings.oInstance;

			if ( ! settings._colReorder ) {
				var dtInit = settings.oInit;
				var opts = dtInit.colReorder || dtInit.oColReorder || {};

				new ColReorder( settings, opts );
			}
			else {
				table.oApi._fnLog( settings, 1, "ColReorder attempted to initialise twice. Ignoring second" );
			}

			return null; /* No node for DataTables to insert */
		},
		"cFeature": "R",
		"sFeature": "ColReorder"
	} );
}
else {
	alert( "Warning: ColReorder requires DataTables 1.9.3 or greater - www.datatables.net/download");
}


// API augmentation
if ( $.fn.dataTable.Api ) {
	$.fn.dataTable.Api.register( 'colReorder.reset()', function () {
		return this.iterator( 'table', function ( ctx ) {
			ctx._colReorder.fnReset();
		} );
	} );

	$.fn.dataTable.Api.register( 'colReorder.order()', function ( set ) {
		if ( set ) {
			return this.iterator( 'table', function ( ctx ) {
				ctx._colReorder.fnOrder( set );
			} );
		}

		return this.context.length ?
			this.context[0]._colReorder.fnOrder() :
			null;
	} );
}

return ColReorder;
}; // /factory


// Define as an AMD module if possible
if ( typeof define === 'function' && define.amd ) {
	define( ['jquery', 'datatables'], factory );
}
else if ( typeof exports === 'object' ) {
    // Node/CommonJS
    factory( require('jquery'), require('datatables') );
}
else if ( jQuery && !jQuery.fn.dataTable.ColReorder ) {
	// Otherwise simply initialise as normal, stopping multiple evaluation
	factory( jQuery, jQuery.fn.dataTable );
}


})(window, document);



/*PLUGINS*/

///bibmas using datatables extension/plugin 
/*
Accent neutralise
Replace accented characters with unaccented counterparts
Author: Allan Jardine
*/
//cdn.datatables.net/plug-ins/725b2a2115b/filtering/type-based/accent-neutralise.js

jQuery.fn.DataTable.ext.type.search.string = function ( data ) {
    return ! data ?
        '' :
        typeof data === 'string' ?
            data
                .replace( /έ/g, 'ε')
                .replace( /ύ/g, 'υ')
                .replace( /ό/g, 'ο')
                .replace( /ώ/g, 'ω')
                .replace( /ά/g, 'α')
                .replace( /ί/g, 'ι')
                .replace( /ή/g, 'η')
                .replace( /\n/g, ' ' )
                .replace( /á/g, 'a' )
                .replace( /é/g, 'e' )
                .replace( /í/g, 'i' )
                .replace( /ó/g, 'o' )
                .replace( /ú/g, 'u' )
                .replace( /ê/g, 'e' )
                .replace( /î/g, 'i' )
                .replace( /ô/g, 'o' )
                .replace( /è/g, 'e' )
                .replace( /ï/g, 'i' )
                .replace( /ü/g, 'u' )
                .replace( /ã/g, 'a' )
                .replace( /õ/g, 'o' )
                .replace( /ç/g, 'c' )
                .replace( /ì/g, 'i' ) :
            data;
};

//$(document).ready(function() {
      //var table = $('#example').dataTable();
 
      //// Remove accented character from search input as well
      //$('#myInput').keyup( function () {
        //table
          //.search(
            //jQuery.fn.DataTable.ext.type.search.string( this )
          //)
          //.draw()
      //} );
  //} );
  
  
  
///bibmas using datatables extension/plugin  
/*
Anti-"the"

Sort with the prefixed word The removed, if present

*/
//cdn.datatables.net/plug-ins/725b2a2115b/sorting/anti-the.js

/**
 * Often a list of data which has titles in it (books, albums etc) will have
 * the word "the" at the start of some individual titles, which you don't want
 * to include in your sorting order. This plug-in will strip the word "the"
 * from the start of a string and sort on what is left.
 *
 *  @name Anti-"the"
 *  @summary Sort with the prefixed word `dt-string The` removed, if present
 *  @author [Allan Jardine](http://sprymedia.co.uk)
 *
 *  @example
 *    $('#example').dataTable( {
 *       columnDefs: [
 *         { type: 'anti-the', targets: 0 }
 *       ]
 *    } );
 */

jQuery.extend( jQuery.fn.dataTableExt.oSort, {
	"anti-the-pre": function ( a ) {
		return a.replace(/^(the)|(die)|(das)|(der)|(a)|(an)|(ein)|(eine)|(une)|(un) /i, "");
	},

	"anti-the-asc": function ( a, b ) {
		return ((a < b) ? -1 : ((a > b) ? 1 : 0));
	},

	"anti-the-desc": function ( a, b ) {
		return ((a < b) ? 1 : ((a > b) ? -1 : 0));
	}
} );

	//default: return a.replace(/^the /i, "");
	//variant: return a.replace(/^(<(?:.|\n)*?>)*(the)|(die)|(das)|(der)|(a)|(an)|(ein)|(eine)|(une)|(un) /i, "");
		

    
///bibmas using datatables extension/plugin 
/*
/// //cdn.datatables.net/plug-ins/725b2a2115b/api/page.jumpToData().js
// Example: var table = $('#example').DataTable();
//  table.page.jumpToData( "Allan Jardine", 0 );


jQuery.fn.dataTable.Api.register( 'page.jumpToData()', function ( data, column ) {
    var pos = this.column(column, {order:'current'}).data().indexOf( data );
 
    if ( pos >= 0 ) {
        var page = Math.floor( pos / this.page.info().length );
        this.page( page ).draw( false );
    }
 
    return this;
} );
*/

//http://datatables.net/forums/discussion/21211/mistake-in-page-jumptodata
/*
$.fn.dataTable.Api.register( 'page.jumpToData()', function ( data, column) {
 
    var dt, pos, i;
    dt = this.columns( column).data() ;
    if ($.isArray(data)) {
        // data and columns are arrays
        
        for (pos = dt[0].indexOf( data[0]); pos >= 0; pos = dt[0].indexOf( data[0], pos+1)) {
            // check match on remaining values
            for (i = 1; i < dt.length  &&  (dt[i][pos] == data[i]); i++) {
            }
            if (i === dt.length) break; // found a match
        }
    } else {
        
        pos = dt.indexOf( data ); // find index in column array matching data
    }
 
    if ( pos >= 0 ) {
        var page = Math.floor( pos / this.page.info().length );
        this.page( page ).draw( false );
    } else ShowStatusMessage("jumpToData(): no position found (searching '"+ data +"' in col. "+column + ", time: "+new Date().yyyymmddThhmmse(),1);
  
    return this;
} );

///bibmas using datatables extension/plugin 
//http://datatables.net/plug-ins/api/fnGetColumnIndex

/**
 * Maintenance of web-sites can often cause unexpected headaches, particularly
 * if the hardcoded index of an array (the columns in a DataTables instance)
 * needs to change due to an added or removed column. This plug-in function
 * will match a given string to the title of a column in the table and return
 * the column index, helping to overcome this problem.
 *
 *  @name fnGetColumnIndex
 *  @summary Get the column index by searching the column titles
 *  @author [Michael Ross](http://www.rosstechassociates.com/)
 *
 *  @param {string} sCol Column title to search for
 *  @returns {integer} Column index, or -1 if not found
 *
 *  @example
 *    var table = $('#example').dataTable();
 *    table.fnGetColumnIndex( 'Browser' );
 */
/*
jQuery.fn.dataTableExt.oApi.fnGetColumnIndex = function ( oSettings, sCol )
{
	var cols = oSettings.aoColumns;
	for ( var x=0, xLen=cols.length ; x<xLen ; x++ )
	{
		if ( cols[x].sTitle.toLowerCase() == sCol.toLowerCase() )
		{
			return x;
		}
	}
	return -1;
};





*/


///bibmas using datatables extension/plugin 
/*




$.fn.dataTable.Api.register( 'page.jumpToRow()', function ( data) {
 
    var dt, pos, i;
    dt = this.rows( column).data() ;
    if ($.isArray(data)) {
        // data and columns are arrays
        
        for (pos = dt[0].indexOf( data[0]); pos >= 0; pos = dt[0].indexOf( data[0], pos+1)) {
            // check match on remaining values
            for (i = 1; i < dt.length  &&  (dt[i][pos] == data[i]); i++) {
            }
            if (i === dt.length) break; // found a match
        }
    } else {
        
        pos = dt.indexOf( data ); // find index in column array matching data
    }
 
    if ( pos >= 0 ) {
        var page = Math.floor( pos / this.page.info().length );
        this.page( page ).draw( false );
    } else ShowStatusMessage("jumpToData(): no position found (searching '"+ data +"' in col. "+column + ", time: "+new Date().yyyymmddThhmmse(),1);
  
    return this;
} );


*/










///bibmas using datatables extension/plugin 
//http://datatables.net/plug-ins/pagination/input
//cdn.datatables.net/plug-ins/725b2a2115b/pagination/input.js
/*Sometimes for quick navigation, it can be useful to allow an end user to enter which page they wish to jump to manually. This paging control uses a text input box to accept new paging numbers (arrow keys are also allowed for), and four standard navigation buttons are also presented to the end user.*/

$.fn.dataTableExt.oPagination.input = {
    "fnInit": function ( oSettings, nPaging, fnCallbackDraw )
    {
        var nFirst = document.createElement( 'span' );
        var nPrevious = document.createElement( 'span' );
        var nNext = document.createElement( 'span' );
        var nLast = document.createElement( 'span' );
        var nInput = document.createElement( 'input' );
        var nPage = document.createElement( 'span' );
        var nOf = document.createElement( 'span' );
 
        nFirst.innerHTML = oSettings.oLanguage.oPaginate.sFirst;
        nPrevious.innerHTML = oSettings.oLanguage.oPaginate.sPrevious;
        nNext.innerHTML = oSettings.oLanguage.oPaginate.sNext;
        nLast.innerHTML = oSettings.oLanguage.oPaginate.sLast;
 
        nFirst.className = "paginate_button first";
        nPrevious.className = "paginate_button previous";
        nNext.className="paginate_button next";
        nLast.className = "paginate_button last";
        nOf.className = "paginate_of";
        nPage.className = "paginate_page";
 
        if ( oSettings.sTableId !== '' )
        {
            nPaging.setAttribute( 'id', oSettings.sTableId+'_paginate' );
            nPrevious.setAttribute( 'id', oSettings.sTableId+'_previous' );
            nPrevious.setAttribute( 'id', oSettings.sTableId+'_previous' );
            nNext.setAttribute( 'id', oSettings.sTableId+'_next' );
            nLast.setAttribute( 'id', oSettings.sTableId+'_last' );
        }
 
        nInput.type = "text";
        nInput.style.width = "25px";
        nInput.style.display = "inline";
        nPage.innerHTML = "Page ";
 
        nPaging.appendChild( nFirst );
        nPaging.appendChild( nPrevious );
        nPaging.appendChild( nPage );
        nPaging.appendChild( nInput );
        nPaging.appendChild( nOf );
        nPaging.appendChild( nNext );
        nPaging.appendChild( nLast );
 
        $(nFirst).click( function () {
            oSettings.oApi._fnPageChange( oSettings, "first" );
            fnCallbackDraw( oSettings );
        } );
 
        $(nPrevious).click( function() {
            oSettings.oApi._fnPageChange( oSettings, "previous" );
            fnCallbackDraw( oSettings );
        } );
 
        $(nNext).click( function() {
            oSettings.oApi._fnPageChange( oSettings, "next" );
            fnCallbackDraw( oSettings );
        } );
 
        $(nLast).click( function() {
            oSettings.oApi._fnPageChange( oSettings, "last" );
            fnCallbackDraw( oSettings );
        } );
 
        $(nInput).keyup( function (e) {
            if ( e.which == 38 || e.which == 39 )
            {
                this.value++;
            }
            else if ( (e.which == 37 || e.which == 40) && this.value > 1 )
            {
                this.value--;
            }
 
            if ( this.value === "" || this.value.match(/[^0-9]/) )
            {
                /* Nothing entered or non-numeric character */
                return;
            }
 
            var iNewStart = oSettings._iDisplayLength * (this.value - 1);
            if ( iNewStart > oSettings.fnRecordsDisplay() )
            {
                /* Display overrun */
                oSettings._iDisplayStart = (Math.ceil((oSettings.fnRecordsDisplay()-1) /
                    oSettings._iDisplayLength)-1) * oSettings._iDisplayLength;
                fnCallbackDraw( oSettings );
                return;
            }
 
            oSettings._iDisplayStart = iNewStart;
            fnCallbackDraw( oSettings );
        } );
 
        /* Take the brutal approach to cancelling text selection */
        $('span', nPaging).bind( 'mousedown', function () { return false; } );
        $('span', nPaging).bind( 'selectstart', function () { return false; } );
    },
 
 
    "fnUpdate": function ( oSettings, fnCallbackDraw )
    {
        if ( !oSettings.aanFeatures.p )
        {
            return;
        }
        var iPages = Math.ceil((oSettings.fnRecordsDisplay()) / oSettings._iDisplayLength);
        var iCurrentPage = Math.ceil(oSettings._iDisplayStart / oSettings._iDisplayLength) + 1;
 
        /* Loop over each instance of the pager */
        var an = oSettings.aanFeatures.p;
        for ( var i=0, iLen=an.length ; i<iLen ; i++ )
        {
            var spans = an[i].getElementsByTagName('span');
            var inputs = an[i].getElementsByTagName('input');
            spans[3].innerHTML = " of "+iPages;
            inputs[0].value = iCurrentPage;
        }
    }
};


///bibmas using datatables extension/plugin 
//cdn.datatables.net/plug-ins/725b2a2115b/filtering/type-based/html.js
/**
* DataTables has a built in type called `html` which will strip HTML tags
* from a search string, but it doesn't cope with nested HTML inside another
* element's attributes (for example DOM0 events with have HTML in them). This
* plug-in function overrules the built-in method and provides complete HTML
* tag removal.
*
* Note that this function is not included in DataTables by
* default because it is slightly slower than the built-in method, which is
* good enough for by far the majority of use cases.
*
* @summary Strip HTML using DOM methods
* @name html
* @author _guillimon_
*
* @example
* $(document).ready(function() {
* $('#example').dataTable({
* "columnDefs": [
* { type: "html", target: 0 }
* ]
* });
* } );*/

/*

(function () {
var _div = document.createElement('div');
jQuery.fn.dataTable.ext.type.search.html = function ( data ) {
_div.innerHTML = data;
return //_div.textContent ?
_div.textContent.replace(/\n/g," ") 
//: _div.innerText.replace(/\n/g," ")
;

};
})();
*/

///bibmas using datatables extension/plugin 
/*
//http://datatables.net/forums/discussion/4025/sorting-to-ignore-empty-cells
jQuery.fn.dataTableExt.oSort['mystring-asc'] = function(x,y) {
    var retVal;
    x = $.trim(x);
    y = $.trim(y);
 
    if (x==y) retVal= 0;
    else if (x == "" || x == "&nbsp;") retVal=  1;
    else if (y == "" || y == "&nbsp;") retVal=  -1;
    else if (x > y) retVal=  1;
    else retVal = -1;  // <- this was missing in version 1
 
    return retVal;
}
jQuery.fn.dataTableExt.oSort['mystring-desc'] = function(y,x) {
    var retVal;
    x = $.trim(x);
    y = $.trim(y);
 
    if (x==y) retVal= 0; 
    else if (x == "" || x == "&nbsp;") retVal=  -1;
    else if (y == "" || y == "&nbsp;") retVal=  1;
    else if (x > y) retVal=  1;
    else retVal = -1; // <- this was missing in version 1
 
    return retVal;
 }
*/
